<?php
// array of versions (does not include versions before Release 2)
$versions=array(
2005062901=>'2rc2',
2005111001=>'2',
2005121401=>'2.1B1',
2006011201=>'2.1',
2006031601=>'2.2B1',
2006041201=>'2.2rc1',
2006050301=>'2.2',
2006121801=>'2.3rc1',
2007052801=>'2.4rc1',
2007060801=>'2.4b3',
2007070301=>'2.4rc2',
2007072301=>'2.4',
2008010701=>'2.4.1'
);

if (isset($argv) && $argv[1]=='c') {
	$command_line = true;
}

if (isset($argv) && $argv[2]=='snet') {
	$smartnet 		= true;
}

if ((isset($argv[3]) && $argv[3]=='v') || isset($_POST['verbose'])) {
	$verbo = true;	
} else {
	$verbo = false;
}
$verbo=true;
$header = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Interact Database Setup - Upgrade</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="../../local/skins/default/interactstyle.css" rel="stylesheet" type="text/css">
<style type="text/css">

body {
	margin: 10px;
}
.message {background-color:transparent; color:#070;}
</style>
</head>
<body>

<div align="center"><img src="../../images/logo.gif"></div>
<h1>Interact Database Setup  - Upgrade Existing Installation</h1>';
if (!isset($command_line)) {
	echo $header;
}
/**
* Include main config file 
*/

$CONFIG['NO_SESSION']='1';
set_time_limit(0);

//if (!isset($CONFIG['SERVER_URL'])) {
    require_once('../../local/config.inc.php');
//}
require_once('testshortURLs.php');


//make a database conection
$CONN = &ADONewConnection($CONFIG['DATABASE_TYPE']); 
if (!$CONN->Connect($CONFIG['DBSERVER'],$CONFIG['DBUSER'],$CONFIG['DBPASSWORD'],$CONFIG['DATABASE'])) {

	echo '<p class="message">The setup scripts were not able to connect to the database that you have specified in your configuration files</p>'.$CONN->ErrorMsg();
	echo '<p>Please check that the following lines in your config.inc.php file are correctly set for your database<br/ >$CONFIG[\'DBUSER\']<br />$CONFIG[\'DBPASSWORD\']<br />$CONFIG[\'DATABASE\']</p>';
	echo '<p align="center"><a href="index.php">Return to setup screen</a></p>';
	exit;
	
}

//first see if new data direcories
if ((!isset($CONFIG['DATA_PATH'])) || (!is_dir($CONFIG['DATA_PATH']))) {

   echo '<p class="message">The data directory "'.$CONFIG['DATA_PATH'].'" does not seem to exist, please make sure this directory exists on your webserver - or change your config file $CONFIG[\'DATA_PATH\'] setting to point to a directory that does exist.</p>';
	exit;
	
}

makeDir($CONFIG['MODULE_FILE_SAVE_PATH']);
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/icons');
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/file');
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/kb');
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/sharing');
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/forum');
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/dropbox');
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/scorm');
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/feedreader');	


if (!isset($command_line)) {
	echo '<div align="center" class="quizFeedback"><p>Upgrading Database Tables...</p></div>';
}

$oldversion=($CONN->GetOne("SELECT version FROM {$CONFIG['DB_PREFIX']}version"))?$CONN->GetOne("SELECT version FROM {$CONFIG['DB_PREFIX']}version"):$CONN->GetOne("SELECT Version FROM {$CONFIG['DB_PREFIX']}Version");
if(!$oldversion) {

	if ($CONN->Execute("SELECT UserKey FROM {$CONFIG['DB_PREFIX']}Users")===false && $CONN->Execute("SELECT UserKey FROM Users")===false && $CONN->Execute("SELECT user_key FROM {$CONFIG['DB_PREFIX']}users")===false) {
	
		echo '<p class="message">You don\'t appear to have Interact installed, please check your database settings in your includes/config.inc.php file, or use the database installation option if this is a new installation of Interact.</p>';
			echo '<p align="center"><a href="index.php">Return to setup screen</a></p>';
		exit;
	}
	
	
	//see if version 1.7 being upgraded
	if ($CONN->Execute("SELECT JournalEntryKey FROM {$CONFIG['DB_PREFIX']}JournalEntries")===false && $CONN->Execute("SELECT JournalEntryKey FROM JournalEntries")===false && $CONN->Execute("SELECT post_key FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		run17Upgrade();
	} 
	
	
	//see if version 1.8 being upgraded
	if ($CONN->Execute("SELECT SortOrderKey FROM {$CONFIG['DB_PREFIX']}SortOrders")===false && $CONN->Execute("SELECT AccountStatusKey FROM UserStatuses")===false) {
		run18Upgrade();
	} 
	
	
	//see if version 1.8.5 being upgraded
	if ($CONN->Execute("SELECT Version FROM {$CONFIG['DB_PREFIX']}Version")===false) {
		run185Upgrade();
	} 
	
	
	//see if version 1.8.6 being upgraded
	if ($CONN->Execute("SELECT ModuleKey FROM {$CONFIG['DB_PREFIX']}DropboxDownloadLinks")===false) {
		require_once('updateforums.php');
		run186Upgrade();
	} 
	
	
	//see if version 1.8.7 being upgraded
	if ($CONN->Execute("SELECT DateAdded FROM {$CONFIG['DB_PREFIX']}GroupUserLinks")===false) {
		require_once('updatecategories.php');
		run187Upgrade();
	} 
	
	
	//see if version 1.9 being upgraded
	$rs = $CONN->Execute("SELECT Release FROM {$CONFIG['DB_PREFIX']}Version WHERE Release='1.9'");
	if ($rs!==FALSE && !$rs->EOF) {run19Upgrade();} 

	//1.9.1 had no database updates.
	//see if >= version 1.9.2 being upgraded
	$oldversion=$CONN->GetOne("SELECT Version FROM {$CONFIG['DB_PREFIX']}Version");
	if (!$oldversion) {echo 'Cannot detect old version number.  Upgrade failed.';exit;}

	//Note: a previous upgrade may have broken Version string - hence >2147483646 value.
	if ($oldversion<2005030401 || $oldversion>2147483646) {
		run2005030401Upgrade();
		$oldversion=2005030401;
	}
}


//////////////////////////////////////////////////////
//   handle all Release 2 and above upgrades...     //
//////////////////////////////////////////////////////
foreach($versions as $v=>$release) {
	if($oldversion<$v) {
		if ($verbo) echo '<h2>Release '.$release.'</h2>';
		call_user_func('run'.$v.'Upgrade');
	
		// earlier upgrades set version themselves.
		if($v>2006050301) {
			if($v>=2007052801) {
				$vname='version';$rname='release_name';
			} else {
				$vname='Version';$rname='ReleaseName';
			}
			if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}$vname SET $vname='$v', $rname='$release'")===false) {
		   		echo '<p class="error">There was a problem updating the '.$CONFIG['DB_PREFIX'].$vname.' table: '.$CONN->ErrorMsg().'</p>';
			} else {
				if ($verbo) echo "<p>The database version has been updated to Interact Release $release - $v.</p>";
			}
		}
	}
}

if($oldversion<$v) {
	if (!isset($command_line)) {
		echo '<div align="center" class="quizFeedback">
		<p>Upgrade Complete!</p>
		<p align="center">Visit the <strong><a href="'.$CONFIG['FULL_URL'].'/admin/settings.php">server settings page</a></strong> to check your settings.</a></p>
		<p>If you have your own language translations,<br />visit the <a href="'.$CONFIG['FULL_URL'].'/admin/language/index.php">languages</a> page to recompile them.</p>';
	}
} else {
	if (!isset($command_line)) {	
		echo '<div align="center" class="quizFeedback">
<p>No upgrades necessary!  Your database is already up to date.</p>';
	}

}

if (!isset($command_line)) {
	echo '<p align="center">Return to <a href="index.php">main setup page</a>.</p><p align="center"><a href="'.$CONFIG['FULL_URL'].'/">site home page</a>.</p></div>';
}

//always run DEV upgrade, but this will be empty for public releases.
run_DEV_Upgrade();

if (!isset($command_line)) {
	echo'</body></html>';
}

function makeDir($dirPath) {
	global $verbo;
	if (!is_dir($dirPath)) {
		if (!mkdir($dirPath,0777)) {
			echo '<p class="message">There was a problem creating the directory '.$dirPath.'<br />Please check that your webserver has write access to allow this and then try running this script again</p>';
			exit;
		} else {if ($verbo) echo '<p>Created '.$dirPath.' directory</p>';}
	}
}

// runSQL -- simplify DB calls, testing and messages.
// message: what it's doing (in present-tense).  Putting this first makes code readable.
// test_sql: test whether change has already been made (can be -ve or +ve test)

function runSQL($message,$sql,$test_sql='',$exit_on_err=true,$negative_test=true,$show_err=true) {
	global $CONN,$verbo;
	$test_sql=DBrep($test_sql); $sql=DBrep($sql); $message=DBrep($message);

	if($test_sql=='' || ($negative_test XOR !($CONN->Execute($test_sql.' LIMIT 1')===FALSE))) {

		if ($CONN->Execute($sql)===false) {
			if($show_err) echo '<p class="error">'.$message.' FAILED: <em>'.$CONN->ErrorMsg().'</em></p>';
			if ($exit_on_err) exit;
		} elseif ($verbo && $message) {echo '<span class="message">'.$message.'</span><br />';}
	}
}

function DBrep($string) {
	global $CONFIG;
	return str_replace('[DB]',$CONFIG['DB_PREFIX'],$string);
}

// adds column IF NOT EXISTS in table.
function addColumn($table, $col_details, $exit_on_err=true) {
	global $CONN;
	$col_name=substr($col_details,0,strpos($col_details,' '));
	if($CONN->Execute(DBrep("SELECT $col_name FROM [DB]$table LIMIT 1"))===false) {
		runSQL("Add field $col_name to [DB]$table",
			"ALTER TABLE [DB]$table ADD $col_details",'',$exit_on_err);
	}
}

function createTable($table,$description) {
	global $CONN;
	if($CONN->Execute(DBrep("SELECT * FROM [DB]$table LIMIT 1"))===false) {
		runSQL("Create [DB]$table table", "CREATE TABLE [DB]$table ($description)");
	}
}

function dropTable($table) {
	global $CONN;
	if($CONN->Execute(DBrep("SELECT * FROM [DB]$table LIMIT 1"))!==false) {
		runSQL("Drop [DB]$table table","DROP TABLE [DB]$table");
	}
}


/////
//
// 1.7 - 1.8 upgrade functions
//
/////
function run17Upgrade() {

    global $CONN, $CONFIG, $verbo;
	if ($verbo) echo "<h2>Running version 1.7 - 1.8 upgrade functions</h2>";
	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE JournalEntries (
        JournalEntryKey int(11) NOT NULL auto_increment,
        ModuleKey int(11) NOT NULL default '0',
        MultiEntryKey int(11) NOT NULL default '0',
        UserKey int(11) NOT NULL default '0',
        AdminKey int(11) NOT NULL default '0',
        DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
        DateModified datetime NOT NULL default '0000-00-00 00:00:00',
        Body mediumtext NOT NULL,
        PRIMARY KEY  (JournalEntryKey),
        KEY UserKeyIdx (UserKey),
        KEY ModuleKeyIdx (ModuleKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the JournalEntries table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The JournalEntries table has been successfully created</p>';
	
    }

	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE JournalEntryComments (
        CommentKey int(11) NOT NULL auto_increment,
        JournalEntryKey int(11) NOT NULL default '0',
        ParentKey int(11) NOT NULL default '0',
        UserKey int(11) NOT NULL default '0',
        Body text NOT NULL,
        DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
        DateModified date NOT NULL default '0000-00-00',
        PRIMARY KEY  (CommentKey),
        KEY JournalEntryKeyIdx (JournalEntryKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the JournalEntryComments table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The JournalEntryComments table has been successfully created</p>';
	
    }
	
	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE JournalSettings (
        ModuleKey int(11) NOT NULL default '0',
        TypeKey tinyint(4) NOT NULL default '0',
        StartDate datetime NOT NULL default '0000-00-00 00:00:00',
        FinishDate datetime NOT NULL default '0000-00-00 00:00:00',
        PRIMARY KEY  (ModuleKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the JournalSettings table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The JournalSettings table has been successfully created</p>';
	
    }
	
	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE JournalTypes (
        TypeKey int(11) NOT NULL auto_increment,
        Name varchar(20) NOT NULL default '',
        PRIMARY KEY  (TypeKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the JournalTypes table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The JournalTypes table has been successfully created</p>';
	
    }

    /////////////////////////////////////////////////

    if ($CONN->Execute("INSERT INTO JournalTypes VALUES 
	    (1,'Open'),
	    (2,'Closed')")===false) {

        echo '<p class="message">There was a problem adding the default JournalTypes: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The default journal types have been successfully added</p>';
	
    }
	
    /////////////////////////////////////////////////

    if ($CONN->Execute("INSERT INTO ModuleTypes VALUES (14,'Journal','journal','','','journal')")===false) {

        echo '<p class="message">There was a problem adding the journal module type: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The journal module type has been successfully added</p>';
	
    }
	    /////////////////////////////////////////////////

    if ($CONN->Execute("ALTER TABLE SharedItems ADD FilePath varchar(11) NOT NULL AFTER FileName")===false) {

        echo '<p class="message">There was a problem adding new field to the Shared Items Table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>New field for SharedItems table successfully added</p>';
	
    }
	
	return true;	
}

/////
//
// 1.8 - 1.8.5 upgrade functions
//
/////
function run18Upgrade() {

    global $CONN, $CONFIG, $verbo;
	
	if ($verbo) echo "<h2>Running version 1.8 - 1.8.5 upgrade functions</h2>";
	
		    /////////////////////////////////////////////////

    if ($CONN->Execute("SELECT FilePath FROM {$CONFIG['DB_PREFIX']}SharedItems")===false) {
	
	    if ($CONN->Execute("ALTER TABLE SharedItems ADD FilePath varchar(11) NOT NULL AFTER FileName")===false) {

            echo '<p class="message">There was a problem adding new field to the Shared Items Table: '.$CONN->ErrorMsg().'</p>';} else {

            if ($verbo) echo '<p>New field for SharedItems table successfully added</p>';
	
        }
		
	}
	
	    /////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE UserStatuses (
        AccountStatusKey tinyint(4) NOT NULL auto_increment,
        Name varchar(20) NOT NULL default '',
        PRIMARY KEY  (AccountStatusKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the UserStatuses table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The UserStatuses table has been successfully created</p>';
	
    }


    /////////////////////////////////////////////////

    if ($CONN->Execute("INSERT INTO UserStatuses VALUES 
	    ('','Active'),
	    ('','Disabled')")===false) {

        echo '<p class="message">There was a problem adding the default user statuses: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The default user statuses have been successfully added</p>';
	
    }
	
	/////////////////////////////////////////////////

    if ($CONN->Execute("ALTER TABLE ModuleTypes CHANGE Image Image varchar(15) not null")===false) {

        echo '<p class="message">There was a problem update the ModuleTypes Image Field: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The default ModuleTypes Image Field has been successfully updated</p>';
	
    }
	
	/////////////////////////////////////////////////
	
    if ($CONN->Execute("ALTER TABLE Users ADD UserIDNumber varchar(20) not null after Password")===false) {

        echo '<p class="message">There was a problem adding UserIDNumber to the User table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The default UserIDNumber field has been successfully added</p>';
	
    }
	
		/////////////////////////////////////////////////
	
    if ($CONN->Execute("INSERT INTO ModuleTypes VALUES (15,'Noticeboard','noticeboard','','','noticeboard')")===false) {

        echo '<p class="message">There was a problem adding the Noticeboard module type: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The Noticeboard module type has been successfully added</p>';
	
    }
  
  	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE NoticeboardSettings (
        ModuleKey int(11) NOT NULL default '0',
        TypeKey tinyint(4) NOT NULL default '0',
        DaysToKeep tinyint(2) NOT NULL default '0',
        PRIMARY KEY  (ModuleKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the NoticeboardSettings table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The NoticeboardSettings table has been successfully created</p>';
	
    }
	
	  	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE Notices (
        NoticeKey int(11) NOT NULL auto_increment,
        ModuleKey int(11) NOT NULL default '0',
        Heading varchar(60) NOT NULL default '',
        Body text NOT NULL,
        DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
        RemoveDate date NOT NULL default '0000-00-00',
        UserKey int(11) NOT NULL default '0',
        PRIMARY KEY  (NoticeKey),
        KEY SpaceKeyIdx (ModuleKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the Notices table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The Notices table has been successfully created</p>';
	
    }
	
		  	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE Languages (
        LanguageKey tinyint(4) NOT NULL auto_increment,
        Code varchar(3) NOT NULL default '',
        Name varchar(50) NOT NULL default '',
        PRIMARY KEY  (LanguageKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the Languages table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The Languages table has been successfully created</p>';
	
    }

	/////////////////////////////////////////////////
	
    if ($CONN->Execute("INSERT INTO Languages VALUES (1,'eng','English')")===false) {

        echo '<p class="message">There was a problem adding the default languages: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The default languages have been successfully added</p>';
	
    }
	
	/////////////////////////////////////////////////
	
    if ($CONN->Execute("ALTER TABLE Users ADD LanguageKey  tinyint(3) after AccountStatus")===false) {

        echo '<p class="message">There was a problem adding the language key field to the Users table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The language key field has been successfully added</p>';
	
    }
	
	////////////////////////////////////////////////
	
    if ($CONN->Execute("UPDATE Users SET LanguageKey='1'")===false) {

        echo '<p class="message">There was a problem adding the Users language key field: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The language key field has been successfully updated</p>';
	
    }
	
		////////////////////////////////////////////////
	
    if ($CONN->Execute("DROP TABLE SortOrders")===false) {

        echo '<p class="message">There was a problem dropping the SortOrders table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The Sort Orders table has been successfully dropped</p>';
	
    }
	
	////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE SortOrders (
        SortOrderKey tinyint(4) NOT NULL auto_increment,
        SortOrder varchar(20) NOT NULL default '',
        SortSql varchar(30) NOT NULL default '',
        PRIMARY KEY  (SortOrderKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the SortOrders table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The SortOrders  table has been successfully created</p>';
	
    }
	
	/////////////////////////////////////////////////
	
    if ($CONN->Execute("INSERT INTO SortOrders VALUES 
	    (1,'Date Added Desc','Modules.DateAdded DESC'),
	    (2,'Numeric','ModuleSpaceLinks.SortOrder'),
	    (3,'Alpha','Modules.Name'),
	    (4,'Date Modified Desc','Modules.DateModified DESC'),
	    (5,'Date Modified','Modules.DateModified'),
	    (6,'Date Added','Modules.DateAdded')")===false) {

        echo '<p class="message">There was a problem adding the default sort orders: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The default sort orders have been successfully added</p>';
	
    }
	
	//now rename all the tables
	$CONN->Execute("ALTER TABLE AccessLevels RENAME AS {$CONFIG['DB_PREFIX']}AccessLevels");
	$CONN->Execute("ALTER TABLE CalendarEvents RENAME AS {$CONFIG['DB_PREFIX']}CalendarEvents");
	$CONN->Execute("ALTER TABLE Calendars RENAME AS {$CONFIG['DB_PREFIX']}Calendars");
	$CONN->Execute("ALTER TABLE Categories RENAME AS {$CONFIG['DB_PREFIX']}Categories");
	$CONN->Execute("ALTER TABLE CommonNavigationLinks RENAME AS {$CONFIG['DB_PREFIX']}CommonNavigationLinks");	
	$CONN->Execute("ALTER TABLE DefaultSpaceUserLinks RENAME AS {$CONFIG['DB_PREFIX']}DefaultSpaceUserLinks");
	$CONN->Execute("ALTER TABLE DropboxFileStatus RENAME AS {$CONFIG['DB_PREFIX']}DropboxFileStatus");
	$CONN->Execute("ALTER TABLE DropboxFiles RENAME AS {$CONFIG['DB_PREFIX']}DropboxFiles");
	$CONN->Execute("ALTER TABLE DropboxSettings RENAME AS {$CONFIG['DB_PREFIX']}DropboxSettings");
	$CONN->Execute("ALTER TABLE Files RENAME AS {$CONFIG['DB_PREFIX']}Files");
	$CONN->Execute("ALTER TABLE FolderSettings RENAME AS {$CONFIG['DB_PREFIX']}FolderSettings");							
	$CONN->Execute("ALTER TABLE Forum RENAME AS {$CONFIG['DB_PREFIX']}posts");
	$CONN->Execute("ALTER TABLE ForumAutoPromptActions RENAME AS {$CONFIG['DB_PREFIX']}ForumAutoPromptActions");
	$CONN->Execute("ALTER TABLE ForumAutoPrompts RENAME AS {$CONFIG['DB_PREFIX']}ForumAutoPrompts");
	$CONN->Execute("ALTER TABLE ForumThreadManagement RENAME AS {$CONFIG['DB_PREFIX']}ForumThreadManagement");
	$CONN->Execute("ALTER TABLE ForumSettings RENAME AS {$CONFIG['DB_PREFIX']}ForumSettings");

	$CONN->Execute("ALTER TABLE GroupSettings RENAME AS {$CONFIG['DB_PREFIX']}GroupSettings");	
	$CONN->Execute("ALTER TABLE GroupUserLinks RENAME AS {$CONFIG['DB_PREFIX']}GroupUserLinks");
	$CONN->Execute("ALTER TABLE JournalEntries RENAME AS {$CONFIG['DB_PREFIX']}JournalEntries");
	$CONN->Execute("ALTER TABLE JournalEntryComments RENAME AS {$CONFIG['DB_PREFIX']}JournalEntryComments");
	$CONN->Execute("ALTER TABLE JournalSettings RENAME AS {$CONFIG['DB_PREFIX']}JournalSettings");
	$CONN->Execute("ALTER TABLE JournalTypes RENAME AS {$CONFIG['DB_PREFIX']}JournalTypes;");					
	$CONN->Execute("ALTER TABLE Languages RENAME AS {$CONFIG['DB_PREFIX']}Languages");					
	$CONN->Execute("ALTER TABLE LinkEditRights RENAME AS {$CONFIG['DB_PREFIX']}LinkEditRights");					
	$CONN->Execute("ALTER TABLE ModuleEditRightLinks RENAME AS {$CONFIG['DB_PREFIX']}ModuleEditRightLinks");					
	$CONN->Execute("ALTER TABLE ModuleEditRights RENAME AS {$CONFIG['DB_PREFIX']}ModuleEditRights");					
	$CONN->Execute("ALTER TABLE ModuleSpaceLinks RENAME AS {$CONFIG['DB_PREFIX']}ModuleSpaceLinks");					
	$CONN->Execute("ALTER TABLE ModuleStatus RENAME AS {$CONFIG['DB_PREFIX']}ModuleStatus");					
	$CONN->Execute("ALTER TABLE ModuleTypes RENAME AS {$CONFIG['DB_PREFIX']}ModuleTypes");					
	$CONN->Execute("ALTER TABLE News RENAME AS {$CONFIG['DB_PREFIX']}News");
	$CONN->Execute("ALTER TABLE Notes RENAME AS {$CONFIG['DB_PREFIX']}Notes");
    $CONN->Execute("ALTER TABLE Notices RENAME AS {$CONFIG['DB_PREFIX']}Notices");	
	$CONN->Execute("ALTER TABLE NoticeboardSettings RENAME AS {$CONFIG['DB_PREFIX']}NoticeboardSettings");
	$CONN->Execute("ALTER TABLE Pages RENAME AS {$CONFIG['DB_PREFIX']}Pages");
    $CONN->Execute("ALTER TABLE PostType RENAME AS {$CONFIG['DB_PREFIX']}PostType");	
	$CONN->Execute("ALTER TABLE ReadPosts RENAME AS {$CONFIG['DB_PREFIX']}ReadPosts");
	$CONN->Execute("ALTER TABLE SharedItemComments RENAME AS {$CONFIG['DB_PREFIX']}SharedItemComments");
	$CONN->Execute("ALTER TABLE SharedItems RENAME AS {$CONFIG['DB_PREFIX']}SharedItems");
	$CONN->Execute("ALTER TABLE SharingSettings RENAME AS {$CONFIG['DB_PREFIX']}SharingSettings");
	$CONN->Execute("ALTER TABLE SortOrders RENAME AS {$CONFIG['DB_PREFIX']}SortOrders");
	$CONN->Execute("ALTER TABLE SpaceCategoryLinks RENAME AS {$CONFIG['DB_PREFIX']}SpaceCategoryLinks");
	$CONN->Execute("ALTER TABLE SpaceStatus RENAME AS {$CONFIG['DB_PREFIX']}SpaceStatus");
	$CONN->Execute("ALTER TABLE SpaceType RENAME AS {$CONFIG['DB_PREFIX']}SpaceType");
	$CONN->Execute("ALTER TABLE SpaceUserLinks RENAME AS {$CONFIG['DB_PREFIX']}SpaceUserLinks");
	$CONN->Execute("ALTER TABLE Spaces RENAME AS {$CONFIG['DB_PREFIX']}Spaces");
	$CONN->Execute("ALTER TABLE Statistics RENAME AS {$CONFIG['DB_PREFIX']}Statistics");
	$CONN->Execute("ALTER TABLE UserGroups RENAME AS {$CONFIG['DB_PREFIX']}UserGroups");
	$CONN->Execute("ALTER TABLE UserStatuses RENAME AS {$CONFIG['DB_PREFIX']}UserStatuses");
	$CONN->Execute("ALTER TABLE UserUserGroupLinks RENAME AS {$CONFIG['DB_PREFIX']}UserUserGroupLinks");
	$CONN->Execute("ALTER TABLE Users RENAME AS {$CONFIG['DB_PREFIX']}Users");
	$CONN->Execute("ALTER TABLE WebLinks RENAME AS {$CONFIG['DB_PREFIX']}WebLinks");
	$CONN->Execute("ALTER TABLE sessions RENAME AS {$CONFIG['DB_PREFIX']}Sessions");
	$CONN->Execute("ALTER TABLE Modules RENAME AS {$CONFIG['DB_PREFIX']}Modules");																										

	return true;	
}

/////
//
// 1.8.5 - 1.8.6 upgrade functions
//
/////
function run185Upgrade() {

    global $CONN, $CONFIG, $verbo;
	if ($verbo) echo "<h2>Running version 1.8.5 - 1.8.6 upgrade functions</h2>";


	/////////////////////////////////////////////////

    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}ModuleTypes VALUES ('','Gradebook','gradebook','','','gradebook')")===false) {

        echo '<p class="message">There was a problem adding the gradebook '.$CONFIG['DB_PREFIX'].'ModuleTypes table values: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes table values have been successfully added</p>';
	
    }	
	
	/////////////////////////////////////////////////

    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}UserStatuses VALUES ('','To be deleted')")===false) {

        echo '<p class="message">There was a problem adding the to be deleted value '.$CONFIG['DB_PREFIX'].'UserStatuses table value: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes table values have been successfully added</p>';
	
    }
	
	///////////////////////////////////////////////////////

 if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}GradebookItems (
  ItemKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  ScaleKey int(11) NOT NULL default '0',
  Name varchar(100) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  Url varchar(150) NOT NULL default '', 
  ContentModuleKey int(11) NOT NULL default '0',
  SortOrder tinyint(3) NOT NULL default '0', 
  DueDate datetime NOT NULL default '0000-00-00 00:00:00',
  MaximumScore tinyint(3) NOT NULL default '0',
  Weighting tinyint(3) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ItemKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'GradebookItems  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GradebookItems table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}GradebookItemUserLinks (
  ItemKey int(11) NOT NULL auto_increment,
  UserKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  GradeKey int(3) NOT NULL default '0',
  Comments mediumtext NOT NULL,   
  UNIQUE(ItemKey, UserKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'GradebookItemUserLinks  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GradebookItemUserLinks table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}GradebookScales (
  ScaleKey int(11) NOT NULL auto_increment,
  Name varchar(100) NOT NULL default '',
  Description text NOT NULL default '',
  SpaceKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ScaleKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'GradebookScales table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GradebookScales table has been successfully created</p>';
	
}

/////////////////////////////////////////////////


if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}GradebookScales VALUES 
(1,'Numeric','Standard numeric scale',0,0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00'),
(2,'Alpha','Standard a-f Alpha scale',0,0,'2003-11-03 10:02:23',0,'0000-00-00 00:00:00'),
(3,'Pass/Fail','',0,0,'2003-11-03 10:05:25',0,'0000-00-00 00:00:00'),
(4,'Complete','Basic complete/incomplete grading',0,0,'2003-11-03 10:06:33',0,'0000-00-00 00:00:00')")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'GradebookScales table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'GradebookScales table </p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}GradebookScaleGrades (
  GradeKey int(11) NOT NULL auto_increment,  
  ScaleKey int(11) NOT NULL default '0',
  Grade varchar(255) NOT NULL default '',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (GradeKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'GradebookScaleGrades table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GradebookScaleGrades table has been successfully created</p>';
	
}

/////////////////////////////////////////////////


if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}GradebookScaleGrades VALUES 
(1,2,'A',1,'2003-11-03 10:03:36',0,'0000-00-00 00:00:00'),
(2,2,'A+',1,'2003-11-03 10:03:44',0,'0000-00-00 00:00:00'),
(3,2,'A-',1,'2003-11-03 10:03:49',0,'0000-00-00 00:00:00'),
(4,2,'B',1,'2003-11-03 10:03:53',0,'0000-00-00 00:00:00'),
(5,2,'B+',1,'2003-11-03 10:03:58',0,'0000-00-00 00:00:00'),
(6,2,'B-',1,'2003-11-03 10:04:03',0,'0000-00-00 00:00:00'),
(7,2,'C',1,'2003-11-03 10:04:09',0,'0000-00-00 00:00:00'),
(8,2,'C+',1,'2003-11-03 10:04:13',0,'0000-00-00 00:00:00'),
(9,2,'C-',1,'2003-11-03 10:04:18',0,'0000-00-00 00:00:00'),
(10,2,'D',1,'2003-11-03 10:04:22',0,'0000-00-00 00:00:00'),
(11,2,'D+',1,'2003-11-03 10:04:27',0,'0000-00-00 00:00:00'),
(12,2,'D-',1,'2003-11-03 10:04:31',0,'0000-00-00 00:00:00'),
(13,2,'E',1,'2003-11-03 10:04:37',0,'0000-00-00 00:00:00'),
(14,2,'E+',1,'2003-11-03 10:04:45',0,'0000-00-00 00:00:00'),
(15,2,'E-',1,'2003-11-03 10:04:50',0,'0000-00-00 00:00:00'),
(16,2,'F',1,'2003-11-03 10:04:54',0,'0000-00-00 00:00:00'),
(17,3,'Pass',1,'2003-11-03 10:05:37',0,'0000-00-00 00:00:00'),
(18,3,'Fail',1,'2003-11-03 10:05:42',0,'0000-00-00 00:00:00'),
(19,3,'Resubmit',1,'2003-11-03 10:05:49',0,'0000-00-00 00:00:00'),
(20,3,'Pass with distinction',1,'2003-11-03 10:06:02',0,'0000-00-00 00:00:00'),
(21,3,'Complete',1,'2003-11-03 10:06:45',0,'0000-00-00 00:00:00'),
(22,3,'Incomplete',1,'2003-11-03 10:06:45',0,'0000-00-00 00:00:00')")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'GradebookScaleGrades table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'GradebookScaleGrades table </p>';
	
}



if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}Users VALUES ('','deleteduser','xyz123','','Deleted','User','deleted@deleteduser.com','Account used when deleting users from system - do not remove','4','','','','','','2','1')")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'Users table </p>';
	
}
	
///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}UserNotes (
  UserNoteKey tinyint(4) NOT NULL auto_increment,
  Url varchar(255) NOT NULL default '',
  Note text NOT NULL default '',
  added_for_key int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  SpaceKey int(11) NOT NULL default '0',    
  GroupKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (UserNoteKey),
  KEY added_for_keyIdx (added_for_key),
  KEY SpaceKeyIdx (SpaceKey),
  KEY GroupKeyIdx (GroupKey)
) TYPE=MyISAM")===false) {


    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'UserNotes  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'UserNotes table has been successfully created</p>';
	
}
		
///////////////////////////////////////////////////////

if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}DropboxFiles ADD GradebookItemKey int(11) NOT NULL default '0' AFTER UserKey")===false) {

    echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'DropboxFiles  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxFiles table has been successfully updated</p>';
	
}


/////////////////////////////////////////////////


if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}DateFormats (
  FormatKey int(11) NOT NULL default '0',
  Format varchar(15) NOT NULL default '',
  Type varchar(5) NOT NULL default ''  
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'DateFormats table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DateFormats table has been successfully created</p>';
	
}

/////////////////////////////////////////////////

if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}DateFormats VALUES (0,'dd-mm-yy','short'),
(1,'mm-dd-yy','short'),
(2,'d-m-yy','short'),
(3,'m-d-yy','short'),
(4,'dd-mm-yyyy','short'),
(5,'mm-dd-yyyy','short'),
(6,'d-m-yyyy','short'),
(7,'m-d-yyyy','short'),
(0,'d Jan 2003','long'),
(1,'d January 2003','long'),
(2,'January d 2003','long'),
(3,'Jan d 2003','long')")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'DateFormats table: '.$CONN->ErrorMsg().'</p>';
	} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'DateFormats table </p>';
	
}

/////////////////////////////////////////////////

if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD ShortDateFormatKey tinyint(4) NOT NULL AFTER Header")===false) {

    echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
}

/////////////////////////////////////////////////

if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD LongDateFormatKey  tinyint(4) NOT NULL AFTER Header")===false) {

    echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
}
/////////////////////////////////////////////////

if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}SpaceStatus VALUES 
(3,'Hidden'),
(4,'Archived')")===false) {

    echo '<p class="message">There was a problem adding values to  the '.$CONFIG['DB_PREFIX'].'SpaceStatus table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'SpaceStatus table was successfuly updated</p>';
	
}

	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}Version (
        Version int(11) NOT NULL default '0',
        Release varchar(10) NOT NULL default ''
        ) TYPE=MyISAM;")===false) {

        echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Version table has been successfully created</p>';
	
    }
	/////////////////////////////////////////////////

    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}Version VALUES ('2003120101','1.8.6')")===false) {

        echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'Version table values: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Version table values have been successfully added</p>';
	
    }	

	return true;	
}

/////
//
// 1.8.6 - 1.8.7 upgrade functions
//
/////
function run186Upgrade() {

    global $CONN, $CONFIG, $verbo;
/////////////////////////////////////////////////

if ($verbo) echo "<h2>Running version 1.8.6 - 1.8.7 upgrade functions</h2>";
if ($CONN->Execute("SELECT StatusKey FROM {$CONFIG['DB_PREFIX']}Categories")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Categories ADD StatusKey tinyint(2) NOT NULL AFTER CategoryParent")===false) {

        echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'Categories table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Categories table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Categories Status field already exists</p>';

}

/////////////////////////////////////////////////

if ($CONN->Execute("SELECT SortOrder FROM {$CONFIG['DB_PREFIX']}Categories")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Categories ADD SortOrder int(3) NOT NULL AFTER StatusKey")===false) {

        echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'Categories table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Categories table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Categories SortOrder field already exists</p>';

}

/////////////////////////////////////////////////////////////////

if ($CONN->Execute("SELECT SortOrder FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD SortOrder int(3) NOT NULL AFTER LongDateFormatKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces SortOrder field already exists</p>';

}


/////////////////////////////////////////////////////////////////

if ($CONN->Execute("SELECT Type FROM {$CONFIG['DB_PREFIX']}Calendars")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Calendars ADD Type varchar(6) NOT NULL AFTER ParentCalendarKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Calendars table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Calendars table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Calendars Type field already exists</p>';

}
/////////////////////////////////////////////////////////////////

if ($CONN->Execute("SELECT FilePath FROM {$CONFIG['DB_PREFIX']}ForumSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ForumSettings ADD FilePath varchar(20) NOT NULL default '' AFTER MinimumRepliesDefault")===false) {

        echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'ForumSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ForumSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ForumSettings FilePath field already exists</p>';

}

if ($CONN->Execute("SELECT Attachment FROM {$CONFIG['DB_PREFIX']}posts")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts ADD Attachment varchar(40) NOT NULL default '' AFTER ShowPhoto")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Forum table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Forum table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Forum Attachment field already exists</p>';

}

if ($CONN->Execute("SELECT AutoLoadEditor FROM {$CONFIG['DB_PREFIX']}Users")===false) {

    if ($CONN->Execute("Alter table {$CONFIG['DB_PREFIX']}Users ADD AutoLoadEditor tinyint(1) NOT NULL default '1' AFTER LanguageKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'User AutoLoadEditor field already exists</p>';

}




    if ($CONN->Execute("alter table {$CONFIG['DB_PREFIX']}Modules change Description Description text not null")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Modules table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Modules table was successfuly updated</p>';
	
    }
	
if ($CONN->Execute("SELECT TypeKey FROM {$CONFIG['DB_PREFIX']}DropboxSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}DropboxSettings ADD TypeKey tinyint(1) NOT NULL default '1' AFTER FilePath")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'DropboxSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxSettings Type field already exists</p>';

}

if ($CONN->Execute("SELECT TimeAllowed FROM {$CONFIG['DB_PREFIX']}DropboxSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}DropboxSettings ADD TimeAllowed int(4) NOT NULL default '0' AFTER TypeKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'DropboxSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxSettings TimeAllowed field already exists</p>';

}

if ($CONN->Execute("SELECT DownloadFile FROM {$CONFIG['DB_PREFIX']}DropboxSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}DropboxSettings ADD DownloadFile varchar(40) NOT NULL default '' AFTER TimeAllowed")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'DropboxSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxSettings DownloadFile field already exists</p>';

}


$rs = $CONN->Execute("SELECT AccessLevelKey FROM {$CONFIG['DB_PREFIX']}AccessLevels WHERE AccessLevelKey='5'");

if ($rs->RecordCount()<1) {
    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}AccessLevels values ('5','Permanent Guest')")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'AccessLevels table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'AccessLevels table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'AccessLevels permanent guest level already exists</p>';

}

$rs = $CONN->Execute("SELECT SpaceStatusKey FROM {$CONFIG['DB_PREFIX']}SpaceStatus WHERE SpaceStatusKey='5'");
if ($rs->RecordCount()<1) {

    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}SpaceStatus VALUES (5,'Public')")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'SpaceStatus table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'SpaceStatus table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'SpaceStatus public access level already exists</p>';

}

$rs = $CONN->Execute("SELECT ModuleTypeKey FROM {$CONFIG['DB_PREFIX']}ModuleTypes WHERE ModuleTypeKey='17'");
if ($rs->RecordCount()<1) {

    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}ModuleTypes VALUES (17,'Quiz','quiz','','','quiz')")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'ModuleTypes table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes quiz module settings already exist</p>';

}

//drop existing chat tables
$CONN->Execute("DROP TABLE IF EXISTS {$CONFIG['DB_PREFIX']}Chat");
$CONN->Execute("DROP TABLE IF EXISTS {$CONFIG['DB_PREFIX']}ChatUsers");
$CONN->Execute("DROP TABLE IF EXISTS {$CONFIG['DB_PREFIX']}ChatBannlist");
$CONN->Execute("DROP TABLE IF EXISTS {$CONFIG['DB_PREFIX']}ChatRegisteredUsers");
///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QuizSettings (
  ModuleKey int(11) NOT NULL auto_increment,
  TypeKey tinyint(2) NOT NULL default '0',
  OpenDate datetime NOT NULL default '0000-00-00 00:00:00',
  CloseDate datetime NOT NULL default '0000-00-00 00:00:00',
  Attempts tinyint(2) NOT NULL default '0',
  ShuffleQuestions tinyint(1) NOT NULL default '0',
  ShuffleAnswers tinyint(1) NOT NULL default '0', 
  GradingKey tinyint(2) NOT NULL default '0',
  BuildOnPrevious tinyint(1) NOT NULL default '0',
  ShowFeedback tinyint(1) NOT NULL default '0', 
  ShowCorrect tinyint(1) NOT NULL default '0',
  MinutesAllowed int(3) NOT NULL default '0',            
  KEY ModuleKeyIdx (ModuleKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QuizSettings table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QuizSettings table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTItem (
  ItemKey int(11) NOT NULL auto_increment,
  Name varchar(255) NOT NULL default '',
  Mattext text NOT NULL default '',
  ResponseType varchar(5) NOT NULL default '',
  RenderType varchar(20) NOT NULL default '',
  Rcardinality varchar(10) NOT NULL default '',
  Rtiming varchar(3) NOT NULL default '',
  AddedByKey int(11) NOT NULL default '0',
  ModifiedByKey int(11) NOT NULL default '0', 
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',     
  PRIMARY KEY  (ItemKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTItem table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTItem table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTResponse (
  ItemKey int(11) NOT NULL default '0',
  Mattext text NOT NULL default '',
  Ident varchar(100) NOT NULL default '',
  UNIQUE  (Ident)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTResponse table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTResponse table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTResprocessing (
  ItemKey int(11) NOT NULL default '0',
  ResponseIdent varchar(100) NOT NULL default '',
  Correct tinyint(1) NOT NULL default '0',
  Score tinyint(3) NOT NULL default '',
  FeedbackType varchar(100) NOT NULL default '',
  FeedbackLinkrefid varchar(100) NOT NULL default '',
  unique(ItemKey,ResponseIdent)  
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTResprocessing table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTResprocessing table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTFeedback (
  ItemKey int(11) NOT NULL default '0',
  FeedbackLinkrefid varchar(100) NOT NULL default '',
  Mattext text NOT NULL default ''
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTFeedback table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTFeedback table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTCategories (
  CategoryKey int(11) NOT NULL auto_increment,
  ParentKey int(11) NOT NULL default '0',
  Name varchar(255) NOT NULL default '',
  UserKey int(11) NOT NULL default '0',
  SpaceKey int(11) NOT NULL default '0',
  PRIMARY KEY  (CategoryKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTCategories table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTCategories table has been successfully created</p>';
	
}


///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTCategoryItemLinks(
  CategoryKey int(11) NOT NULL default '0',
  ItemKey int(11) NOT NULL default '0',
  UNIQUE  (CategoryKey, ItemKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTCategoryItemLinks table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTCategoryItemLinks table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTModuleItemLinks(
  LinkKey int(11) NOT NULL auto_increment,  
  ModuleKey int(11) NOT NULL default '0',
  ItemKey int(11) NOT NULL default '0',
  SortOrder int(4) NOT NULL default '0',
  Score int(4) NOT NULL default '0',
  PRIMARY KEY  (LinkKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTModuleItemLinks table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTModuleItemLinks table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTAttempts(
  AttemptKey int(11) NOT NULL auto_increment,  
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  TimeStarted datetime NOT NULL default '0000-00-00 00:00:00', 
  TimeFinished datetime NOT NULL default '0000-00-00 00:00:00',    
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00', 
  Score int(4) NOT NULL default '0',
  PRIMARY KEY  (AttemptKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTAttempts table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTAttempts table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTAttemptsData(
  AttemptKey int(11) NOT NULL auto_increment,  
  ItemKey int(11) NOT NULL default '0',
  ResponseIdent varchar(100) NOT NULL default '',
  Correct tinyint(1) NOT NULL default '0',  
  Unique (AttemptKey, ItemKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTAttemptsData table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTAttemptsData table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}ChatMessages (
   type tinyint(1) DEFAULT '0' NOT NULL,
   room varchar(60) NOT NULL,
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   m_time int(11) DEFAULT '0' NOT NULL,
   address varchar(30) NOT NULL,
   message text NOT NULL
)")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'ChatMessages  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ChatMessages table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}ChatUsers (
   room varchar(60) NOT NULL,
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   u_time int(11) DEFAULT '0' NOT NULL,
   status varchar(1) NOT NULL,
   ip varchar(16) NOT NULL,
   UNIQUE room (room, username)
)")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'ChatUsers  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ChatUsers table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}ChatRegUsers (
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   password varchar(32) NOT NULL,
   firstname varchar(64) NOT NULL,
   lastname varchar(64) NOT NULL,
   country varchar(64) NOT NULL,
   website varchar(64) NOT NULL,
   email varchar(64) NOT NULL,
   showemail tinyint(1) NOT NULL,
   perms varchar(9) NOT NULL,
   rooms varchar(128) NOT NULL,
   reg_time int(11) DEFAULT '0' NOT NULL,
   ip varchar(16) NOT NULL,
   gender tinyint(1) DEFAULT '0' NOT NULL
)")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'ChatRegUsers  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ChatRegUsers table has been successfully created</p>';
	
}

/////////////////////////////////////////////////


if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}ChatRegUsers VALUES
('admin', '', '21232f297a57a5a743894a0e4a801fc3', '', '', '', '', '', 0, 'admin', '', '', '', '')")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'ChatRegUsers table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'ChatRegUsers table </p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}ChatBanUsers (
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   ip varchar(16) NOT NULL,
   rooms varchar(100) NOT NULL,
   ban_until int(11) DEFAULT '0' NOT NULL
)")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'ChatBanUsers  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ChatBanUsers table has been successfully created</p>';
	
}

/////////////////////////////////////////////////


if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2004040501', Release='1.8.7'
")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'Version table </p>';
	
}
/////////////////////////////////////////////////


if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}CategoryExternalLinks (
  LinkKey int(11) NOT NULL auto_increment,
  CategoryKey int(11) NOT NULL default '0',
  Name varchar(255) NOT NULL default '',
  Url varchar(200) NOT NULL default '',
  SortOrder int(3) NOT NULL default '0',
  PRIMARY KEY  (LinkKey),    
  KEY CategoryKeyIdx (CategoryKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'CategoryExternalLinks table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'CategoryExternalLinks table has been successfully created</p>';
	
}

/////////////////////////////////////////////////


if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Categories SET StatusKey='1'")===false) {

    echo '<p class="message">There was a problem updating the '.$CONFIG['DB_PREFIX'].'Categories table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Categories table has been successfully updated</p>';
	
}
///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}DropboxDownloadLinks (
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',  
  TimeDownloaded datetime NOT NULL default '0000-00-00 00:00:00',
  TimeUploaded datetime NOT NULL default '0000-00-00 00:00:00',
  FileName varchar(45) NOT NULL default '', 
  UNIQUE  (ModuleKey, UserKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'DropboxDownloadLinks table: '.$CONN->ErrorMsg().'</p>';
	
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxDownloadLinks table has been successfully created</p>';
	
}

//remove waffle language settings

$rs = $CONN->Execute("SELECT LanguageKey FROM {$CONFIG['DB_PREFIX']}Languages WHERE Code='wfl'"); 
while (!$rs->EOF) {

    $language_key = $rs->fields[0];
	$rs->MoveNext();
	
}
$CONN->Execute("DELETE FROM {$CONFIG['DB_PREFIX']}Languages WHERE LanguageKey='$language_key'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Languages SET LanguageKey='1' WHERE LanguageKey='$language_key'");
return true;

}

/////
//
// 1.8.7 - 1.8.8 upgrade functions
//
/////
function run187Upgrade() {

    global $CONN, $CONFIG, $verbo;
/////////////////////////////////////////////////

if ($verbo) echo "<h2>Running version 1.8.7 - 1.8.8 upgrade functions</h2>";
if ($CONN->Execute("SELECT DateAdded FROM {$CONFIG['DB_PREFIX']}GroupUserLinks")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupUserLinks ADD DateAdded datetime NOT NULL default '0000-00-00 00:00:00' AFTER AccessLevelKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'GroupUserLinks table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupUserLinks table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupUserLinks DateAdded field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT DateAdded FROM {$CONFIG['DB_PREFIX']}SpaceUserLinks")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}SpaceUserLinks ADD DateAdded datetime NOT NULL default '0000-00-00 00:00:00' AFTER AccessLevelKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'SpaceUserLinks table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'SpaceUserLinks table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'SpaceUserLinks DateAdded field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT AccessKey FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings ADD AccessKey tinyint(4) NOT NULL default '1' AFTER SortOrderKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings AccessKey field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT AccessCode FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings ADD AccessCode varchar(10) NOT NULL default '' AFTER AccessKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings AccessCode field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT VisibilityKey FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings ADD VisibilityKey tinyint(4) NOT NULL default '2' AFTER AccessCode")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings VisibilityKey field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT MaximumUsers FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings ADD MaximumUsers tinyint(4) NOT NULL default '0' AFTER VisibilityKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings MaximumUsers field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT IconKey FROM {$CONFIG['DB_PREFIX']}ModuleSpaceLinks")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks ADD IconKey int(11) NOT NULL default '1' AFTER StatusKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks IconKey field already exists</p>';

}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}Icons (
  IconKey int(11) NOT NULL auto_increment,
  Name varchar(30) NOT NULL default '',
  Description varchar(255) NOT NULL default '',  
  SmallIcon varchar(30) NOT NULL default '',
  LargeIcon varchar(30) NOT NULL default '',
  Primary KEY GroupKey (IconKey)
) TYPE=MyISAM;")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'Icons table: '.$CONN->ErrorMsg().'</p>';
		
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Icons table has been successfully created</p>';
	
}

/////////////////////////////////////////////////


if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}Icons VALUES 
	('0','Default',' Default system icon','',''),
	('2',' None','No icon','','')
")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Icons table: '.$CONN->ErrorMsg().'</p>';
		
} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'Icons table </p>';
	
}

//////////////////////////////////////////////////

$rs = $CONN->Execute("SELECT ModuleTypeKey FROM {$CONFIG['DB_PREFIX']}ModuleTypes WHERE Code='kb'");
if ($rs->EOF) {

    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}ModuleTypes VALUES ('','KnowledgeBase','kb','','','kb')")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'ModuleTypes table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes KB entry already exists</p>';

}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBSettings (
  ModuleKey int(11) NOT NULL default '0',
  AccessLevelKey tinyint(4) NOT NULL default '0',
  FilePath varchar(50) NOT NULL default '',
  PRIMARY KEY  (ModuleKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBSettings table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBSettings table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBCategories (
  CategoryKey int(11) NOT NULL auto_increment,
  ParentKey int(11) NOT NULL default '0',
  ModuleKey int(11) NOT NULL default '0',  
  Name varchar(255) NOT NULL default '',
  PRIMARY KEY  (CategoryKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBCategories table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBCategories table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBTemplates (
  TemplateKey int(11) NOT NULL auto_increment,
  TypeKey tinyint(1) NOT NULL default '0',
  Name varchar(100) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  SummaryFields tinyint(1) NOT NULL default '1',  
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (TemplateKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBTemplates table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBTemplates table has been successfully created</p>';
	
}

/////////////////////////////////////////////////

if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}KBTemplates VALUES 
(1,0,'Glossary','For entering word definitions',1,4,'2004-06-08 14:08:06',0,'0000-00-00 00:00:00'),
(2,0,'FAQs','For entering Frequently Asked Questions',1,4,'2004-07-05 15:39:16',0,'0000-00-00 00:00:00'),
(3,0,'Files','For sharing files',1,4,'2004-07-05 15:47:38',0,'0000-00-00 00:00:00'),
(4,0,'Links','For sharing links to websites',1,4,'2004-07-05 15:48:50',0,'0000-00-00 00:00:00')
")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'KBTemplates table: '.$CONN->ErrorMsg().'</p>';
		
} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'KBtemplates table </p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBEntries (
  EntryKey int(11) NOT NULL auto_increment,
  TemplateKey int(11) NOT NULL default '0',
  ModuleKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (EntryKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBEntries table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBEntries table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBEntryData (
  DataKey int(11) NOT NULL auto_increment,
  EntryKey int(11) NOT NULL default '0',
  FieldKey int(11) NOT NULL default '0',
  Data text not null default '',
  PRIMARY KEY  (DataKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBEntryData table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBEntryData table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBModuleTemplateLinks (
  ModuleKey int(11) NOT NULL default '0',
  TemplateKey int(11) NOT NULL default '0',
  UNIQUE  (ModuleKey, TemplateKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBModuleTemplateLinks table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBModuleTemplateLinks table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBEntryCategoryLinks (
  EntryKey int(11) NOT NULL default '0',
  CategoryKey int(11) NOT NULL default '0',
  UNIQUE  (EntryKey, CategoryKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBEntryCategoryLinks table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBEntryCategoryLinks table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBFields (
  FieldKey int(11) NOT NULL auto_increment,
  TemplateKey int(11) NOT NULL default '0',
  TypeKey tinyint(1) NOT NULL default '0',
  Name varchar(50) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  DisplayOrder tinyint(2) NOT NULL default '0',
  NumberOfLines tinyint(2) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',  
  PRIMARY KEY (FieldKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBFields table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBFields table has been successfully created</p>';
	
}

/////////////////////////////////////////////////

if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}KBFields VALUES 
(1,1,1,'Word','Enter the word to be defined',1,1,4,'2004-06-08 14:08:27',0,'0000-00-00 00:00:00'),
(2,1,1,'Definition','Enter the definition of the word',2,15,4,'2004-06-08 14:08:45',0,'0000-00-00 00:00:00'),
(3,2,1,'Question','Enter question including ?',1,1,4,'2004-07-05 15:45:56',0,'0000-00-00 00:00:00'),
(4,2,1,'Answer','Enter the answer to the question',2,15,4,'2004-07-05 15:46:17',0,'0000-00-00 00:00:00'),
(5,3,1,'Title','Title of file',1,1,4,'2004-07-05 15:47:55',0,'0000-00-00 00:00:00'),
(6,3,1,'Description','Description of file',2,15,4,'2004-07-05 15:48:13',0,'0000-00-00 00:00:00'),
(7,3,3,'File','Upload file',3,0,4,'2004-07-05 15:48:30',0,'0000-00-00 00:00:00'),
(8,4,1,'Title','Title of website',1,1,4,'2004-07-05 15:49:22',0,'0000-00-00 00:00:00'),
(9,4,1,'Description','Description of website',2,15,4,'2004-07-05 15:49:42',0,'0000-00-00 00:00:00'),
(10,4,2,'Url','Url of website',3,0,4,'2004-07-05 15:49:55',0,'0000-00-00 00:00:00')
")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'KBTemplates table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'KBtemplates table </p>';
	
}

///////////////////////////////////////////////////

if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}QTModuleItemLinks CHANGE Score Score FLOAT(3,1) not null default '0'")===false) {

    echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'QTModuleItemLinks table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTModuleItemLinks table has been successfully updated</p>';
	
}

///////////////////////////////////////////////////

if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}QTResprocessing CHANGE Score Score FLOAT(3,1) not null default '0'")===false) {

    echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'QTResprocessing table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTResprocessing table has been successfully updated</p>';
	
}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT Embedded FROM {$CONFIG['DB_PREFIX']}Files")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Files ADD Embedded tinyint(1) not null AFTER FileName")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Files table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Files table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Files embedded field  already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT EntryKey FROM {$CONFIG['DB_PREFIX']}posts")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add EntryKey int(11) not null after ThreadKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Forum table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Forum table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Forum entrykey field  already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT TagKey FROM {$CONFIG['DB_PREFIX']}Tags")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}UserNotes RENAME AS {$CONFIG['DB_PREFIX']}Tags")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'UserNotes table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'UserNotes table was successfuly renamed to Tags</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'UserNote table already renamed</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT TagKey FROM {$CONFIG['DB_PREFIX']}Tags")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Tags CHANGE UserNoteKey TagKey int(11) NOT NULL auto_increment")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Tags table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Tags table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'UserNoteKey  already renamed</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT Heading FROM {$CONFIG['DB_PREFIX']}Tags")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Tags ADD Heading varchar(100) not null after Url")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Tags table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Tags table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Heading field  already exists</p>';

}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}TagCategories (
  CategoryKey int(11) NOT NULL auto_increment,
  ParentKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',  
  Name varchar(255) NOT NULL default '',
  PRIMARY KEY  (CategoryKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'TagCategories  table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'TagCategories table has been successfully created</p>';
	
}


///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}TagCategoryLinks (
  CategoryKey int(11) NOT NULL auto_increment,
  TagKey int(11) NOT NULL default '0',
  UNIQUE  (CategoryKey, TagKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'TagCategoryLinks  table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'TagCategoryLinks table has been successfully created</p>';
	
}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT ReadPostsFlag FROM {$CONFIG['DB_PREFIX']}Users")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Users ADD ReadPostsFlag tinyint(1) NOT NULL default '0' AFTER AutoLoadEditor")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users ReadPostsFlag field  already exists</p>';

}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}SpaceChildLinks (
  SpaceKey int(11) NOT NULL default '0',
  ParentKey int(11) NOT NULL default '0',
  UNIQUE KEY SpaceKey (SpaceKey,ParentKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'SpaceChildLinks table: '.$CONN->ErrorMsg().'</p>';

	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'SpaceChildLinks table has been successfully created</p>';
	
}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT ShortName FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD ShortName varchar(20) NOT NULL default '' AFTER Code")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces ShortName field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT CombineNames FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD CombineNames tinyint(1) NOT NULL default '0' AFTER ShortName")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces CombineNames field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT AccessLevelKey FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD AccessLevelKey tinyint(4) NOT NULL default '0' AFTER Description")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces AccessLevelKey field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT VisibilityKey FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD VisibilityKey tinyint(4) NOT NULL default '0' AFTER AccessLevelKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces VisibilityKey field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT ShowMembers FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD ShowMembers tinyint(1) NOT NULL default '1' AFTER SortOrder")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces ShowMembers field already exists</p>';

}

$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET VisibilityKey='2' WHERE StatusKey='3' OR StatusKey='4'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET VisibilityKey='1' WHERE StatusKey='1' OR StatusKey='2' OR StatusKey='5'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET AccessLevelKey='1' WHERE StatusKey='1'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET AccessLevelKey='2' WHERE StatusKey='2' OR StatusKey='3' OR StatusKey='4'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET AccessLevelKey='3' WHERE StatusKey='5'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET AccessLevelKey='2' WHERE TypeKey='4'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET VisibilityKey='3' WHERE TypeKey='4'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET ShortName=Code WHERE TypeKey='1'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET CombineNames='1' WHERE TypeKey='1'");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces DROP StatusKey");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces DROP TypeKey");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ReadPosts RENAME AS {$CONFIG['DB_PREFIX']}PostUserLinks");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}PostUserLinks ADD ReadStatus tinyint(2) NOT NULL AFTER UserKey");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}PostUserLinks ADD FlagStatus tinyint(2) NOT NULL AFTER ReadStatus");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}PostUserLinks ADD MonitorPost tinyint(2) NOT NULL AFTER FlagStatus");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}PostUserLinks SET ReadStatus='1'");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks ADD INDEX DateAddedIdx (DateAdded)"); 
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks ADD INDEX GroupKeyIdx (GroupKey)"); 
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Tags SET Heading=Note"); 
/////////////////////////////////////////////////

if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2004080701', Release='1.9'
")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'Version table </p>';
	
}

} //end run187Upgrade 

function run19Upgrade() {

	global $CONN, $CONFIG, $verbo;

	//////////////////////////////////////////////////

	if ($CONN->Execute("SELECT NavigationMode FROM {$CONFIG['DB_PREFIX']}FolderSettings")===false) {

    		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}FolderSettings ADD NavigationMode tinyint(1) NOT NULL default '0' AFTER SortOrderKey")===false) {

        		echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'FolderSettings table: '.$CONN->ErrorMsg().'</p>';} 

		else {

        		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'FolderSettings table was successfuly altered</p>';
	
    		}
	
	} else {


	    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'FolderSettings NavigationMode field already exists</p>';

	}

	//////////////////////////////////////////////////

	if ($CONN->Execute("SELECT AccountCreationPassword FROM {$CONFIG['DB_PREFIX']}UserGroups")===false) {

    		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}UserGroups ADD AccountCreationPassword varchar(15) NOT NULL default '0' AFTER GroupName")===false) {

        		echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'UserGroups table: '.$CONN->ErrorMsg().'</p>';} 

		else {

        		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'UserGroups table was successfuly altered</p>';
	
    		}
	
	} else {


	    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'UserGroups AccountCreationPassword field already exists</p>';

	}

	//////////////////////////////////////////////////

	if ($CONN->Execute("SELECT PreferedName FROM {$CONFIG['DB_PREFIX']}Users")===false) {

    		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Users ADD PreferedName varchar(30) NOT NULL default '0' AFTER LastName")===false) {

        		echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';
				
			} else {

        		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users table was successfuly altered</p>';
	
    		}
	
	} else {


	    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users PreferedName field already exists</p>';

	}

	/////////////////////////////////////////////////

	if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}AccessLevels VALUES (5,'Permanent Guest')")===false) {

    		if ($verbo) echo '<p>Could not add the default Access levels: '.$CONN->ErrorMsg().' (they probably exist already)</p>';
	
	} else {

    		if ($verbo) echo '<p>The default access level 5 has been successfully added</p>';
	
	}

	
	$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}AccessLevels SET Name='Admin' WHERE AccessLevelKey='2'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}AccessLevels SET Name='User' WHERE AccessLevelKey='3'");

	/////////////////////////////////////////////////

	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2004092701', Release='1.9.1'")===false) {

    		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    
		if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'Version table </p>';
		
	}


} //end run19upgrade
//////////////////////////////////
function run2005030401Upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $short_urls;
	
	///////////////////////////////////////////////////////
	if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}Skins (
  	SkinKey int(11) NOT NULL auto_increment,
  	UserKey int(11) NOT NULL default '0',
  	Template varchar(20) NOT NULL default '',
  	ScopeKey tinyint(2) NOT NULL default '0',
  	Name varchar(20) NOT NULL default '',
  	BodyBackground varchar(11) NOT NULL default '',
  	BodyFont varchar(50) NOT NULL default '',
  	BodyBorderColour varchar(11) NOT NULL default '',
  	OuterBoxBackground varchar(11) NOT NULL default '',
  	OuterBoxBorderColour varchar(11) NOT NULL default '',
  	HeaderLogo varchar(255) NOT NULL default '',
  	HeaderLogoHeight varchar(6) NOT NULL default '',
  	HeaderLogoWidth varchar(6) NOT NULL default '',
  	HeaderHeight varchar(6) NOT NULL default '',
  	HeaderBackground varchar(11) NOT NULL default '',
  	HeaderBorderColour varchar(50) NOT NULL default '',
	ServerNameColour varchar(11) NOT NULL default '',
  	InnerBoxBackground varchar(11) NOT NULL default '',
  	InnerBoxBorderColour varchar(11) NOT NULL default '',
  	NavBackground varchar(11) NOT NULL default '',
  	NavBorderColour varchar(11) NOT NULL default '',
  	ContentBackground varchar(11) NOT NULL default '',
  	ContentBorderColour varchar(11) NOT NULL default '',
  	PRIMARY KEY  (SkinKey)
	) TYPE=MyISAM")===false) {

    		echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'Skins table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
			exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Skins table has been successfully created</p>';
	
	}
	///////////////////////////////////////////////////////

	$rs = $CONN->Execute("SELECT * FROM {$CONFIG['DB_PREFIX']}Skins");
	if ($rs->EOF) {
	
		if ($CONN->Execute("insert into {$CONFIG['DB_PREFIX']}Skins values ('','1','default','1','Default','','','','','','','','','','','','','','','','','','')")===false) {
	    	echo '<p class="message">There was a problem adding default value to the '.$CONFIG['DB_PREFIX'].'Skins table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Skins table default values have been successfully created</p>';
		}
	}
	
	///////////////////////////////////////////////////////
	//update kb entry table to allow for new status_key field
	if ($CONN->Execute("SELECT StatusKey FROM {$CONFIG['DB_PREFIX']}KBEntries")===false) {

		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}KBEntries ADD StatusKey tinyint(1) NOT NULL default '2' AFTER DateModified")===false) {

   			echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'KBEntries table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	

		} else {

   			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBEntries table updated</p>';
	
		}

	}		
	///////////////////////////////////////////////////////
	//update adodb seesion table
	if ($CONN->Execute("SELECT EXPIREREF FROM {$CONFIG['DB_PREFIX']}Sessions")===false) {

		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Sessions ADD EXPIREREF varchar(64) AFTER EXPIRY")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Sessions table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Sessions table updated</p>';
	
		}
	}
	
	///////////////////////////////////////////////////////
	//add module key to spaces table
	if ($CONN->Execute("SELECT ModuleKey FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {
	
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD ModuleKey int(11) NOT NULL AFTER SpaceKey")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table updated</p>';
	
		}
	}	
	///////////////////////////////////////////////////////
	//add skin key to spaces table
	if ($CONN->Execute("SELECT SkinKey FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD SkinKey int(11) NOT NULL AFTER ModuleKey")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table updated</p>';
	
		}
	}		
	///////////////////////////////////////////////////////
	//add skin key to users table
	if ($CONN->Execute("SELECT SkinKey FROM {$CONFIG['DB_PREFIX']}Users")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Users ADD SkinKey int(11) NOT NULL AFTER ReadPostsFlag")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users table updated</p>';
	
		}
	}		

	///////////////////////////////////////////////////////
	//change password field to allow for encrypted passwords
	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Users CHANGE Password Password varchar(32) NOT NULL")===false) {

    	echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >Check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users table updated</p>';
	
	}		
	
	///////////////////////////////////////////////////////
	//add new block key to ModuleSpaceLinks table
	if ($CONN->Execute("SELECT BlockKey FROM {$CONFIG['DB_PREFIX']}ModuleSpaceLinks")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks ADD BlockKey tinyint(2) NOT NULL AFTER ParentKey")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks table updated</p>';
	
		}
	}		

	//encrypt existing user passwords
	$rs = $CONN->Execute("SELECT UserKey, Password FROM {$CONFIG['DB_PREFIX']}Users");

	while(!$rs->EOF) {
	
		if (strlen($rs->fields[1])!=32) {
			$password = md5($rs->fields[1]);
			$user_key = $rs->fields[0];
			if ($verbo) echo "ecrypting password for user_key $user_key<br />";
			$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Users SET Password='$password' WHERE UserKey='$user_key'");
		}
		$rs->MoveNext();

	}
	
	//add space moduletype
	$rs = $CONN->Execute("SELECT Code FROM {$CONFIG['DB_PREFIX']}ModuleTypes WHERE Code='space'");
	if ($rs->EOF) {
		if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}ModuleTypes(Name, Code) VALUES ('Space', 'space')")===false) {
		    echo '<p class="message">There was a problem adding the new space module type'.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {
    		if ($verbo) echo '<p>The new space module type has been added</p>';
		}
	}
    
	//add default space
	$rs = $CONN->Execute("SELECT SpaceKey FROM {$CONFIG['DB_PREFIX']}Spaces WHERE Code='XXHOMEXX'");
	if ($rs->EOF) {
		if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}Spaces(Code, ShortName,Name,CombineNames,Description,AccessLevelKey,VisibilityKey,AccessCode,NewUserAlert, ShortDateFormatKey, LongDateFormatKey, SortOrder, ShowMembers) VALUES ('XXHOMEXX', '','Home','0', 'Home','1','1','','false', '1', '1', '0', '0')")===false) {
	    	echo '<p class="message">There was a problem adding the default space values'.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Default space has been added</p>';
			$CONFIG['DEFAULT_SPACE_KEY'] = $CONN->Insert_ID();
			$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}server_settings SET default_space_key='{$CONFIG['DEFAULT_SPACE_KEY']}'"); 
		}
	} else {
		$CONFIG['DEFAULT_SPACE_KEY'] = $rs->fields[0];
	}


	///////////////////////////////////////////////////////
	//see if server_settings table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}server_settings (
  		server_name varchar(100) NOT NULL default '',
  		default_skin_key int(11) NOT NULL default '1',
  		default_language varchar(3) NOT NULL default 'eng',
  		short_date_format tinyint NOT NULL default '0',
  		long_date_format tinyint NOT NULL default '0',
  		error_email varchar(50) NOT NULL default '',
  		no_reply_email varchar(50) NOT NULL default '',
  		email_type varchar(8) NOT NULL default '',
  		sendmail_path varchar(50) NOT NULL default '',
  		sendmail_args varchar(50) NOT NULL default '',
  		email_host varchar(50) NOT NULL default '',
  		email_port int(3) NOT NULL default '',
  		email_auth varchar(5) NOT NULL default '',
  		email_username varchar(50) NOT NULL default '',
  		email_password varchar(20) NOT NULL default '',
  		max_file_upload_size int(11) NOT NULL default '',
  		keep_trash int(3) NOT NULL default '',
  		keep_stale_accounts int(3) NOT NULL default '',
  		show_emails tinyint(1) NOT NULL default '0',
  		secure_server tinyint(1) NOT NULL default '0',
  		secure_account_creation tinyint(1) NOT NULL default '0',
  		account_creation_password varchar(20) NOT NULL default '',
  		secret_hash varchar(100) NOT NULL default '',    
  		allow_tags tinyint(1) NOT NULL default '0',
  		default_space_key int(11) NOT NULL default '0',  
  		global_gradebook tinyint(1) NOT NULL default '0',
  		devolve_account_creation tinyint(1) NOT NULL default '0',
  		self_delete tinyint(1) NOT NULL default '0',
  		display_latest tinyint(1) NOT NULL default '0',
  		usergroup_self_select tinyint(1) NOT NULL default '0',
  		single_accounts tinyint(1) NOT NULL default '0',
  		admin_set_skin tinyint(1) NOT NULL default '0',
  		user_set_skin tinyint(1) NOT NULL default '0', 
  		short_urls tinyint(1) NOT NULL default '0'    
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'server_settings table has been successfully created</p>';
	
	}
	///////////////////////////////////////////////////////
	
	$rs = $CONN->Execute("SELECT server_name FROM {$CONFIG['DB_PREFIX']}server_settings");
	if ($rs->EOF) {
		if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}server_settings VALUES ('Interact',1,'eng',0,0,'noreply@yourdomain.com','webmaster@yourdomian.com','sendmail','/usr/sbin/sendmail','','',0,'2','','',5242880,30,365,2,1,1,'','topsecretstringdonttellanyone',1,".$CONFIG['DEFAULT_SPACE_KEY'].",1,1,1,0,1,1,2,2,".$short_urls.")")===false) {

  			echo '<p class="message">There was a problem adding default values to the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'server_settings default values successfully added</p>';
	
		}
	}
	
	/////////////////////////////////////////////////


	if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}cron (
  			last_run datetime NOT NULL 
   			) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'cron table: '.$CONN->ErrorMsg().'</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'cron table has been successfully created</p>';
	
	}
	/////////////////////////////////////////////////

	$date_time = $CONN->DBDate(date('Y-m-d H:i:s'));

	if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}cron(last_run) VALUES($date_time)")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'cron table default setting: '.$CONN->ErrorMsg().'</p>';

		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'cron table default entry has been successfully added</p>';
	
	}
	///////////////////////////////////////////////////////

	if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}module_subscription_links (
  module_key int(11) NOT NULL default '',
  user_key int(11) NOT NULL default '',
  type_key tinyint(1) NOT NULL default '0',
  UNIQUE(module_key, user_key)
  ) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'module_subscription_links table: '.$CONN->ErrorMsg().'</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'module_subscription_links table has been successfully created</p>';
	
	}



	//now convert all spaces to modules
	require_once('convertspaces.php');
	$converted_spaces = array();
	if ($verbo) echo "Now converting existing Spaces to Modules<br />";

	convert_spaces(0, $converted_spaces);
	
		/////////////////////////////////////////////////

	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2005030401', Release='2.0'")===false) {

    		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    
		if ($verbo) echo '<p>The database version has been updated</p>';
		
	}

} // end run2005030401upgrade
//////////////////////////////////
function run2005062901Upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo;
	
	///////////////////////////////////////////////////////
	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Skins CHANGE HeaderLogo HeaderLogo varchar(255) NOT NULL")===false) {

    		echo '<p class="message">There was a problem changing values in the '.$CONFIG['DB_PREFIX'].'Skins table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    
		if ($verbo) echo '<p>The skins table has been updated</p>';
		
	}	
	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2005062901', Release='2.0'")===false) {

    		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    
		if ($verbo) echo '<p>The database version has been updated</p>';
		
	}	
} // end run2005062901upgrade	

//////////////////////////////////
function run2005111001Upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $short_urls;
	
	///////////////////////////////////////////////////////
	//add new Minimum uses field to groupsettings table
	if ($CONN->Execute("SELECT MinimumUsers FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings ADD MinimumUsers tinyint(4) NOT NULL after MaximumUsers")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table updated</p>';
	
		}
	}		
	///////////////////////////////////////////////////////
	//add new startdate field to groupsettings table
	if ($CONN->Execute("SELECT StartDate FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings add StartDate DateTime NOT NULL after MinimumUsers")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table updated</p>';
	
		}
	}	
	
	///////////////////////////////////////////////////////
	//add new finish date field to groupsettings table
	if ($CONN->Execute("SELECT FinishDate FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings add FinishDate DateTime NOT NULL after StartDate")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table updated</p>';
	
		}
	}	

	///////////////////////////////////////////////////////
	//add new group management field to groupsettings table
	if ($CONN->Execute("SELECT GroupManagement FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings add GroupManagement tinyint(1) NOT NULL after FinishDate")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table updated</p>';
	
		}
	}	

	///////////////////////////////////////////////////////
	//add new type key to spaces table
	if ($CONN->Execute("SELECT TypeKey FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces add TypeKey tinyint(1) not null default '0' after VisibilityKey")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table updated</p>';
	
		}
	}	

	///////////////////////////////////////////////////////
	//add new owned by key to spaces table
	if ($CONN->Execute("SELECT OwnedByKey FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces add OwnedByKey int(11) not null default '0' after TypeKey")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table updated</p>';
	
		}
	}	

	///////////////////////////////////////////////////////
	//change module description field to a text field
	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Modules CHANGE Description Description text NOT NULL DEFAULT''")===false) {
   		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Modules table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >Check your database settings and try again</p>';
		exit;	
	
	} else {

   		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Modules table updated</p>';
	
	}	

	///////////////////////////////////////////////////////
	//see if events type table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}event_types (
  		event_type_key int(11) NOT NULL auto_increment,
  		parent int(11) NOT NULL default '0',
  		name varchar(100) NOT NULL default '',
  		colour varchar(6) NOT NULL default '000000',
  		PRIMARY KEY  (event_type_key),
  		KEY parent (parent)
  		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'event types table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'event_types table has been successfully created</p>';
	
	}
	
	///////////////////////////////////////////////////////
	//add new eventdatefinish  to calendarevents table
	if ($CONN->Execute("SELECT EventDateFinish FROM {$CONFIG['DB_PREFIX']}CalendarEvents")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}CalendarEvents ADD EventDateFinish datetime NOT NULL DEFAULT '0000-00-00 00:00:00'")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'CalendarEvents table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'CalendarEvents table updated</p>';
	
		}
	}	
	///////////////////////////////////////////////////////
	//add new dateflags  to calendarevents table
	if ($CONN->Execute("SELECT DateFlags FROM {$CONFIG['DB_PREFIX']}CalendarEvents")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}CalendarEvents ADD DateFlags tinyint(4) unsigned NOT NULL default '0'")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'CalendarEvents table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'CalendarEvents table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new link field to calendarevents table
	if ($CONN->Execute("SELECT Link FROM {$CONFIG['DB_PREFIX']}CalendarEvents")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}CalendarEvents ADD Link varchar(200) NOT NULL DEFAULT ''")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'CalendarEvents table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'CalendarEvents table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new eventtype  field to calendarevents table
	if ($CONN->Execute("SELECT EventType FROM {$CONFIG['DB_PREFIX']}CalendarEvents")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}CalendarEvents ADD EventType int UNSIGNED NOT NULL DEFAULT '0'")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'CalendarEvents table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'CalendarEvents table updated</p>';
	
		}
	}

	$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}CalendarEvents ADD INDEX EventDateFinishIdx (EventDateFinish)");

    		
	
	///////////////////////////////////////////////////////
	//see if colours table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}colours (
  		colour char(6) NOT NULL default '000000'
  		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'colours table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'colours table has been successfully created</p>';
	
	}
    //add default colours to colours table
    $rs = $CONN->Execute("SELECT colour FROM {$CONFIG['DB_PREFIX']}colours"); 
	if ($rs->EOF) {
		if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}colours(colour) VALUES ('900000'),('701818'),('863200'),('522500'),('374310'),('007000'),('227070'),('004080'),('000090'),('400080'),('800080'),('800040'),('844444'),('CE5C00'),('98722F'),('70703C'),('497749'),('4C8162'),('3D6381'), ('434384'),('685872'),('606060')")===false) {
    		echo '<p class="message">There was a problem adding default colours to the '.$CONFIG['DB_PREFIX'].'colours table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>Default values added to the  '.$CONFIG['DB_PREFIX'].'colours table</p>';
	
		}
	}
	///////////////////////////////////////////////////////
	//see if online users table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}online_users (
  		user_key int(11) NOT NULL default '0',
  		session_id varchar(32) NOT NULL default '',
  		time int(11) NOT NULL default '0',
  		polling tinyint(1) NOT NULL default '0',
  		status_key tinyint(1) NOT NULL default '0',
  		UNIQUE  (user_key, session_id),
  		KEY user_key_idx (user_key)
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'online_users table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'online_users table has been successfully created</p>';
	
	}

	
	///////////////////////////////////////////////////////
	//see if online users_messages table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}user_messages (
  		message_key int(11) NOT NULL auto_increment,
  		added_by_key int(11) NOT NULL default '0',
  		added_for_key int(11) NOT NULL default '0',
  		message varchar(255) NOT NULL default '',
  		status_key tinyint(1) NOT NULL default '0',  
  		time int(11) NOT NULL default '0',
  		PRIMARY KEY(message_key),
  		KEY user_key_idx (added_for_key)
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'user_messages table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'user_messages table has been successfully created</p>';
	
	}

	///////////////////////////////////////////////////////
	//add new status_key field to gradebookitems table
	if ($CONN->Execute("SELECT StatusKey FROM {$CONFIG['DB_PREFIX']}GradeBookItems")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GradebookItems Add StatusKey tinyint(1) NOT NULL default '0' AFTER ContentModuleKey")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'GradeBookItems table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GradeBookItems table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new rawcss field to skins table
	if ($CONN->Execute("SELECT RawCss FROM {$CONFIG['DB_PREFIX']}Skins")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Skins add RawCss text not null after ContentBorderColour")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Skins table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Skins table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new statuskey field to onlineusers table
	if ($CONN->Execute("SELECT status_key FROM {$CONFIG['DB_PREFIX']}online_users")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}online_users add status_key tinyint(1) NOT NULL default '0' after polling")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'online_users table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'online_users table updated</p>';
	
		}
	}
	///////////////////////////////////////////////////////
	//add new admins_add_spaces field to server settings table
	if ($CONN->Execute("SELECT admins_add_spaces FROM {$CONFIG['DB_PREFIX']}server_settings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}server_settings add admins_add_spaces tinyint(1) NOT NULL default '0' after short_urls")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'server_settings table updated</p>';
	
		}
	}	
	
	///////////////////////////////////////////////////////
	//add new user_spaces field to server settings table
	if ($CONN->Execute("SELECT user_spaces FROM {$CONFIG['DB_PREFIX']}server_settings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}server_settings add user_spaces tinyint(1) NOT NULL default '0' after admins_add_spaces")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'server_settings table updated</p>';
	
		}
	}
	///////////////////////////////////////////////////////
	//add new enable_portfolios field to server settings table
	if ($CONN->Execute("SELECT enable_portfolios FROM {$CONFIG['DB_PREFIX']}server_settings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}server_settings add enable_portfolios tinyint(1) NOT NULL default '0' after user_spaces")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'server_settings table updated</p>';
	
		}
	}
	
	
	///////////////////////////////////////////////////////
	//rename Forum to posts table
	if ($CONN->Execute("SELECT PostKey FROM {$CONFIG['DB_PREFIX']}Forum")!=false) {
		if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}Forum to {$CONFIG['DB_PREFIX']}posts")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Forum table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Forum table renamed</p>';
	
		}
	}

	//now do all column renames for forum table
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change PostKey post_key int(11) not null auto_increment");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change ModuleKey module_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change ParentKey parent_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change ThreadKey thread_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change EntryKey entry_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change TypeKey type_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change UserKey added_by_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change Subject subject varchar(100) not null default ''");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change Body body mediumtext not null default ''");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change DateAdded date_added datetime not null default '0000-00-00'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change StatusKey status_key tinyint(1) not null default '0'");
	$CONN->Execute("update {$CONFIG['DB_PREFIX']}posts set ShowPhoto='1' where ShowPhoto='t'");
	$CONN->Execute("update {$CONFIG['DB_PREFIX']}posts set ShowPhoto='0' where ShowPhoto='f'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change ShowPhoto settings tinyint(4) unsigned  not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change Attachment attachment varchar(40) not null default ''");
	
	///////////////////////////////////////////////////////
	//add new extended body to posts table
	if ($CONN->Execute("SELECT extended_body FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add extended_body text not null default '' after body")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'posts table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'posts table updated</p>';
	
		}
	}
	
	///////////////////////////////////////////////////////
	//add new modified_by_key to posts table
	if ($CONN->Execute("SELECT modified_by_key FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add modified_by_key int(11) not null default '0' after added_by_key")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'posts table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'posts table updated</p>';
	
		}
	}
	
	///////////////////////////////////////////////////////
	//add new user_key to posts table
	if ($CONN->Execute("SELECT user_key FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add user_key int(11) not null default '0' after modified_by_key")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'posts table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'posts table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new date_published to posts table
	if ($CONN->Execute("SELECT date_published FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add date_published datetime not null default '0000-00-00' after date_added")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'posts table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'posts table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new date_modified to posts table
	if ($CONN->Execute("SELECT date_modified FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add date_modified datetime not null default '0000-00-00' after date_published")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'posts table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'posts table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new multi_entry_key to posts table
	if ($CONN->Execute("SELECT multi_entry_key FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add multi_entry_key int(11) not null default '0' after entry_key")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'posts table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'posts table updated</p>';
	
		}
	}
	///////////////////////////////////////////////////////
	//rename PostUserLinks to post_user_links table
	if ($CONN->Execute("SELECT PostKey FROM {$CONFIG['DB_PREFIX']}PostUserLinks")!=false) {
		if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}PostUserLinks to {$CONFIG['DB_PREFIX']}post_user_links")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'PostUserLinks table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'PostUserLinks table renamed</p>';
	
		}
	}
	///////////////////////////////////////////////////////
	//rename ForumPostUserLinks to post_user_links table
	if ($CONN->Execute("SELECT PostKey FROM {$CONFIG['DB_PREFIX']}ForumPostUserLinks")!=false) {
		if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}ForumPostUserLinks to {$CONFIG['DB_PREFIX']}post_user_links")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'ForumPostUserLinks table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'PostUserLinks table renamed</p>';
	
		}
	}
	//now update columns in post_user_links table
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}post_user_links change ModuleKey module_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}post_user_links change UserKey user_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}post_user_links change PostKey post_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}post_user_links change ReadStatus read_status tinyint(2) NOT NULL default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}post_user_links change FlagStatus flag_status tinyint(2) NOT NULL default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}post_user_links change MonitorPost monitor_post tinyint(1) NOT NULL default '0'");
	
	///////////////////////////////////////////////////////
	//rename JournalSettings to journal_settings
	if ($CONN->Execute("SELECT ModuleKey FROM {$CONFIG['DB_PREFIX']}JournalSettings")!=false) {
		if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}JournalSettings to {$CONFIG['DB_PREFIX']}journal_settings")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'JournalSettings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'JournalSettings table renamed</p>';
	
		}
	}

	$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}journal_settings SET TypeKey='0' WHERE TypeKey='2'");
	$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}journal_settings SET TypeKey=TypeKey+4");
	//now rename columns in journal_settings table
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}journal_settings change ModuleKey module_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}journal_settings change TypeKey options tinyint(4) unsigned  not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}journal_settings change StartDate start_date datetime not null default '0000-00-00'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}journal_settings change FinishDate finish_date datetime not null default '0000-00-00'");
	
	///////////////////////////////////////////////////////
	//add new entries_to_show to journal_settings table
	if ($CONN->Execute("SELECT entries_to_show FROM {$CONFIG['DB_PREFIX']}journal_settings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}journal_settings add entries_to_show int(2) not null default '15' after options")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'jounral_settings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {


			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'jounral_settings table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//see if journal_user_links table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}journal_user_links (
  		module_key int(11) NOT NULL default '0',
  		user_key int(11) NOT NULL default '0',
  		UNIQUE (module_key,user_key)
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'journal_user_links table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'journal_user_links table has been successfully created</p>';
	
	}
	
	///////////////////////////////////////////////////////
	//see if journal_links table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}journal_links (
  		link_key int(11) NOT NULL auto_increment,
  		module_key int(11) NOT NULL default '0',
  		journal_user_key int(11) NOT NULL default '0',
  		name varchar(255) NOT NULL default '',
  		url varchar(255) NOT NULL default '',
  		PRIMARY KEY  (link_key)
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'journal_links table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'journal_links table has been successfully created</p>';
	
	}

	///////////////////////////////////////////////////////
	//rename Tags to tagged_urls table
	if ($CONN->Execute("SELECT TagKey FROM {$CONFIG['DB_PREFIX']}Tags")!=false) {
		if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}Tags to {$CONFIG['DB_PREFIX']}tagged_urls")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Tags table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Tags table renamed</p>';
	
		}
	}
	//now update columns in bookamrks table tag column table
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}tagged_urls change TagKey UrlKey int(11) not null auto_increment");
	
	///////////////////////////////////////////////////////
	//see if tags table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}tags (
  		tag_key int(11) NOT NULL auto_increment,
  		text varchar(50) NOT NULL default '0',
  		PRIMARY KEY(tag_key),
  		UNIQUE (text)
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'tags table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'tags table has been successfully created</p>';
	
	}

	///////////////////////////////////////////////////////
	//see if tag_links table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}tag_links (
  		tag_key int(11) NOT NULL default '0',
  		user_key int(11) NOT NULL default '0',
  		module_key int(11) NOT NULL default '0',
  		entry_key int(11) NOT NULL default '0',
  		url_key int(11) NOT NULL default '0',
  		date_added datetime NOT NULL default '0000-00-00 00:00:00', 
  		UNIQUE (tag_key,user_key,module_key,entry_key)
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'tag_links table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'tag_links table has been successfully created</p>';
	
	}
	//now add scorm tables
	
	///////////////////////////////////////////////////////

	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}scorm (
  		`module_key` int(11) NOT NULL default '0',
  		`file_path` varchar(50) NOT NULL default '',
  		`version` varchar(9) NOT NULL default '',
  		`launch` int(10) unsigned NOT NULL default '0',
  		`browsemode` tinyint(2) NOT NULL default '0',
  		`auto` tinyint(1) unsigned NOT NULL default '0',
  		`width` int(11) NOT NULL default '0',
  		`height` int(11) NOT NULL default '0',
  		PRIMARY KEY  (`module_key`),
  		KEY `ModuleKeyIdx` (`module_key`)
		) TYPE=MyISAM")===false) {

    		echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'scorm table: '.$CONN->ErrorMsg().'</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'scorm table has been successfully created</p>';
	
		}
		
		///////////////////////////////////////////////////////

		if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}scorm_scoes (
  			`id` int(10) unsigned NOT NULL auto_increment,
  			`module_key` int(10) unsigned NOT NULL default '0',
  			`manifest` varchar(255) NOT NULL default '',
  			`organization` varchar(255) NOT NULL default '',
  			`parent` varchar(255) NOT NULL default '',
  			`identifier` varchar(255) NOT NULL default '',
  			`launch` varchar(255) NOT NULL default '',
  			`parameters` varchar(255) NOT NULL default '',
  			`scormtype` varchar(5) NOT NULL default '',
  			`title` varchar(255) NOT NULL default '',
  			`prerequisites` varchar(200) NOT NULL default '',
  			`maxtimeallowed` varchar(19) NOT NULL default '',
  			`timelimitaction` varchar(19) NOT NULL default '',
  			`datafromlms` varchar(255) NOT NULL default '',
  			`masteryscore` varchar(200) NOT NULL default '',
  			`next` tinyint(1) unsigned NOT NULL default '0',
  			`previous` tinyint(1) unsigned NOT NULL default '0',
  			PRIMARY KEY  (`id`),
  			UNIQUE KEY `id` (`id`),
  			KEY `module_key` (`module_key`)
			) TYPE=MyISAM")===false) {

    			echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'scorm_scoes table: '.$CONN->ErrorMsg().'</p>';
				exit;	
	
			} else {

    			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'scorm_scoes table has been successfully created</p>';
	
			}
			///////////////////////////////////////////////////////

			if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}scorm_scoes_track (
  				`id` int(10) unsigned NOT NULL auto_increment,
  				`userid` int(10) unsigned NOT NULL default '0',
  				`module_key` int(10) NOT NULL default '0',
  				`scoid` int(10) unsigned NOT NULL default '0',
  				`element` varchar(255) NOT NULL default '',
  				`value` longtext NOT NULL,
  				`timemodified` int(10) unsigned NOT NULL default '0',
  				PRIMARY KEY  (`id`),
  				UNIQUE KEY `track` (`userid`,`module_key`,`scoid`,`element`),
  				KEY `userid` (`userid`),
  				KEY `module_key` (`module_key`),
  				KEY `scoid` (`scoid`),
  				KEY `elemeny` (`element`)
				) TYPE=MyISAM")===false) {

    			echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'scorm_scoes_track table: '.$CONN->ErrorMsg().'</p>';
				exit;	
	
			} else {

    			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'scorm_scoes_track table has been successfully created</p>';
	
			}
	
		if ($CONN->GetOne("SELECT ModuleTypeKey FROM {$CONFIG['DB_PREFIX']}ModuleTypes WHERE Code='scorm'")===false) {
			if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}ModuleTypes (ModuleTypeKey,Name,Code,Url,AdminUrl,Image) VALUES (NULL,'IMS/SCORM Package','scorm','','','scorm')")===false) {

    			echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'ModuleTypes table: '.$CONN->ErrorMsg().'</p>';
				echo '<p >Check your database settings and try again</p>';
				exit;	
	
			} else {

    			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes table updated</p>';
	
			}
		}
		///////////////////////////////////////////////////////
		//add new accesslevelkey field to modulespacelinks table
		if ($CONN->Execute("SELECT AccessLevelKey FROM {$CONFIG['DB_PREFIX']}ModuleSpaceLinks")===false) {
			if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks ADD AccessLevelKey int(11) NOT NULL AFTER StatusKey")===false) {

    			echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks table: '.$CONN->ErrorMsg().'</p>';
				echo '<p >Check your database settings and try again</p>';
				exit;	
	
			} else {


				if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks table was updated</p>';
	
			}
		}
		
	//now convert all journal entries and comments to posts
	require_once('convertjournals.php');
	if ($verbo) echo "Now converting journal entries and comments to posts<br />";
	convert_journals();
	//rename old journal entries tables
	if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}JournalEntries to {$CONFIG['DB_PREFIX']}old_journal_entries")===false) {

    	echo '<p class="message">There was a problem renaming the no-longer-required '.$CONFIG['DB_PREFIX'].'JournalEntries table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    	if ($verbo) echo '<p>The no-longer-required '.$CONFIG['DB_PREFIX'].'JournalEntries table renamed was renamed</p>';
	
	}
    //rename old journal comments table
	if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}JournalEntryComments to {$CONFIG['DB_PREFIX']}old_journal_comments")===false) {

    	echo '<p class="message">There was a problem renaming the no-longer-required '.$CONFIG['DB_PREFIX'].'JournalEntryComments table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    	if ($verbo) echo '<p>The no-longer-required '.$CONFIG['DB_PREFIX'].'JournalEntryComments entries table was renamed</p>';
	
	}
    //drop journal types table
	if ($CONN->Execute("drop table {$CONFIG['DB_PREFIX']}JournalTypes")===false) {

    	echo '<p class="message">There was a problem dropping the obsolete '.$CONFIG['DB_PREFIX'].'JournalTypes table: '.$CONN->ErrorMsg().'</p>';
	} else {
    	if ($verbo) echo '<p>The obsolete '.$CONFIG['DB_PREFIX'].'JournalTypes table was dropped</p>';
	
	}
	
	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2005111001', Release='2.1B1'")===false) {

    		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    
		if ($verbo) echo '<p>The database version has been updated</p>';
		
	}	
} // end run2005111001upgrade	

function run2005121401Upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $short_urls;
	
	//only go ahead if headings table doesn't exist yet.
	if (!$CONN->Execute("SELECT module_key FROM {$CONFIG['DB_PREFIX']}headings WHERE module_key=0")) {
		if ($CONN->Execute("CREATE TABLE IF NOT EXISTS `{$CONFIG['DB_PREFIX']}headings` (
	  `module_key` int(11) NOT NULL default '0',
	  `initial_state` tinyint(4) NOT NULL default '0',
	  `level` tinyint(4) NOT NULL default '1',
	  PRIMARY KEY  (`module_key`)
	) TYPE=MyISAM")===false) {
			echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'headings table: '.$CONN->ErrorMsg().'</p>';
			exit;
		} else {
			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'headings table has been successfully created</p>';
		}

	//upgrade old headings with new data
		if($rs=$CONN->Execute("SELECT ModuleKey FROM {$CONFIG['DB_PREFIX']}Modules WHERE ModuleTypeKey=10")) {
			while(!$rs->EOF) {
				if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}headings(module_key,initial_state,level) values ('".$rs->fields[0]."','0','1')")===false) {
					echo '<p class="message">There was a problem adding an entry for heading component #'.$rs->fields[0].' to the '.$CONFIG['DB_PREFIX'].'headings table: '.$CONN->ErrorMsg().'</p>';
					exit;
				}
				$rs->MoveNext();
			}
			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'headings table has been populated with default values for existing headings</p>';
		} else {
			echo '<p class="message">There was a problem finding existing headings to update: '.$CONN->ErrorMsg().'</p>';
			exit;
		}
	} else {
		if ($verbo) echo "{$CONFIG['DB_PREFIX']}headings table already exists - presuming headings upgrade has already been done.";}

	///////////////////////////////////////////////////////
	//update short_urls as it now holds 2 bits of data

	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}server_settings SET short_urls = '$short_urls'")===false) {
		echo '<p class="message">There was a problem updating short_urls with new data in the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';exit;
	} else {
    	if ($verbo) echo '<p>Updated short_urls with new data in the '.$CONFIG['DB_PREFIX'].'server_settings table</p>';	
	}


	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2005121401', Release='2.1RC1'")===false) {
   		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The database version has been updated</p>';
	}	
} //end run2005121401upgrade

function run2006011201Upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $short_urls;
	
	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2006011201', Release='2.1'")===false) {
   		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The database version has been updated</p>';
	}	
} //end run2006011201upgrade



function run2006031601Upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $short_urls;
	
//dump current sessions
	$CONN->Execute('DELETE FROM `'.$CONFIG['DB_PREFIX'].'Sessions'.'`');

	if($CONN->Execute("SELECT SpaceMap FROM {$CONFIG['DB_PREFIX']}Spaces")===FALSE) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD SpaceMap tinyint(1) NOT NULL DEFAULT '0' AFTER ShowMembers;")===FALSE) {
			echo '<p class="message">There was a problem updating the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>'; exit;}
		if ($verbo) echo '<p>Updated the '.$CONFIG['DB_PREFIX'].'Spaces table</p>';
	}

	if($CONN->Execute("SELECT AltHome FROM {$CONFIG['DB_PREFIX']}Spaces")===FALSE) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD AltHome varchar(255) NOT NULL default '' AFTER SpaceMap;")===FALSE) {
			echo '<p class="message">There was a problem updating the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>'; exit;}
		if ($verbo) echo '<p>Updated the '.$CONFIG['DB_PREFIX'].'Spaces table</p>';
	}


	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}server_settings CHANGE default_language default_language varchar(32) NOT NULL DEFAULT 'en'")===FALSE) {
		echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';exit;}
	if ($verbo) echo '<p>Altered the '.$CONFIG['DB_PREFIX'].'server_settings table</p>';	


	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Users CHANGE LanguageKey LanguageKey varchar(32) NOT NULL DEFAULT ''")===FALSE) {
		echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';exit;}
	if ($verbo) echo '<p>Updated LanguageKey in the '.$CONFIG['DB_PREFIX'].'Users table</p>';	

	$lang_trans=array('eng'=>'en','mri'=>'mi','tur'=>'tr','esp'=>'es','jpn'=>'ja');
	if (($rs=$CONN->Execute("SELECT LanguageKey,Code FROM {$CONFIG['DB_PREFIX']}Languages"))===false) {
		if($verbo) echo '<p>Languages already updated</p>';} else {
	
		while(!$rs->EOF) {
			if($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Users SET LanguageKey='".$lang_trans[$rs->fields[1]]."' WHERE LanguageKey='".$rs->fields[0]."'")===FALSE) {
				echo '<p class="message">There was a problem updating the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';exit;}
			$rs->MoveNext();
		}
		if ($verbo) {
			echo '<p>Updated Language Keys with new codes in the '.$CONFIG['DB_PREFIX'].'Users table</p>';	
		}
	}
	
	
	$new_lang_code=$lang_trans[$CONN->GetOne("SELECT default_language FROM {$CONFIG['DB_PREFIX']}server_settings")];
	if($new_lang_code) {if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}server_settings SET default_language='".$new_lang_code."'")===FALSE) {
		echo '<p class="message">There was a problem updating the default language in the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
		exit;
	}
	if ($verbo) echo '<p>Updated default_language in the '.$CONFIG['DB_PREFIX'].'server_settings table</p>';
	}

	if ($CONN->Execute("DROP TABLE IF EXISTS {$CONFIG['DB_PREFIX']}Languages")===FALSE) {
		echo '<p class="message">There was a problem dropping the obsolete '.$CONFIG['DB_PREFIX'].'Languages table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) {
			echo '<p>Dropped the obsolete '.$CONFIG['DB_PREFIX'].'Languages table</p>';	
		}
	}


if ($CONN->Execute("SELECT options FROM {$CONFIG['DB_PREFIX']}server_settings")===false) {
	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}server_settings ADD options smallint UNSIGNED NOT NULL DEFAULT '1'")===FALSE) {
		echo '<p class="message">There was a problem adding the options field to the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
		exit;
	} else {
		if ($verbo) {
			echo '<p>Added the options field to the '.$CONFIG['DB_PREFIX'].'server_settings table</p>';
		}
	}
} else {
	if ($verbo) {
		echo "options field already added to {$CONFIG['DB_PREFIX']}server_settings table.";
	}
}


if ($CONN->Execute("SELECT Release FROM {$CONFIG['DB_PREFIX']}Version")===false) {
	if ($verbo) echo '<p>Release field in the '.$CONFIG['DB_PREFIX'].'Version table already renamed.</p>';} else {

	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Version CHANGE Release ReleaseName varchar(10)")===FALSE) {echo '<p class="message">There was a problem renaming the Release field in the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';exit;} 
	if ($verbo) echo '<p>Renamed Release field to "ReleaseName" in the '.$CONFIG['DB_PREFIX'].'Version table</p>';
} 
	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2006031601', ReleaseName='2.2B1'")===false) {
   		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The database version has been updated</p>';
	}

}

function run2006041201Upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo;
	
	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2006041201', ReleaseName='2.2RC1'")===false) {
   		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The database version has been updated</p>';
	}	
} //end run2006041201upgrade

function run2006050301Upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $smartnet ;
	
if ($CONN->Execute("SELECT auth_type FROM {$CONFIG['DB_PREFIX']}server_settings")===false) {
	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}server_settings ADD auth_type varchar(25) NOT NULL DEFAULT '' AFTER options")===FALSE) {
		echo '<p class="message">There was a problem adding the auth_type field to the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
		exit;
	} else {
		if ($verbo) { 
			echo '<p>Added the auth_type field to the '.$CONFIG['DB_PREFIX'].'server_settings table</p>';
		}
	}
} else {
	if ($verbo) {
		echo "auth_type field already added to {$CONFIG['DB_PREFIX']}server_settings table.";
	}
}	
	
if (!empty($smartnet) && $smartnet==true) {
	$auth_type = 'snet_ldap';	
} else {
	$auth_type = 'dbencrypt';	
}
if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}server_settings SET auth_type='$auth_type'")===false) {
   		echo '<p class="message">There was a problem adding the default auth_type value: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The default auth_type value has been added</p>';
	}
	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2006050301', ReleaseName='2.2'")===false) {
   		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The database version has been updated</p>';
	}	
} //end run2006050301upgrade

function run2006121801Upgrade() {
	global $CONN, $CONFIG, $verbo, $smartnet ;

	addColumn("Spaces","WelcomeMessage MediumText NOT NULL AFTER AltHome");

//1st argument for runSQL is English explanation message.
	runSQL("Add _interact_unauth user to [DB]Users table",
	"INSERT INTO [DB]Users (UserName,Password,FirstName,LastName,Email,Details,LevelKey,DateAdded) VALUES ('_interact_unauth','xyz123','{$general_strings['unauth']}','User','unauthorised@example.com','Account used by Interact for unauthorised (not logged in) content - do not remove','4','2006-06-15 11:04:52')","SELECT * FROM [DB]Users WHERE Username='_interact_unauth'");

	runSQL("Rename deleteduser in [DB]Users table",
	"UPDATE [DB]Users SET UserName='_interact_deleted' WHERE UserName = 'deleteduser'",
	"SELECT * FROM [DB]Users WHERE Username='_interact_deleted'");

	runSQL("Update LanguageKey in [DB]Users table",
	"ALTER TABLE [DB]Users CHANGE LanguageKey LanguageKey varchar(32) NOT NULL DEFAULT 'en'");

	addColumn("server_settings", "proxy_server VARCHAR(100) NOT NULL AFTER auth_type");

	addColumn("server_settings", "proxy_port INT(4) NOT NULL AFTER proxy_server");

	addColumn("server_settings", "proxy_username VARCHAR(20) NOT NULL AFTER proxy_server");

	addColumn("server_settings", "proxy_password VARCHAR(20) NOT NULL AFTER proxy_username");

	createTable("feedreader_settings",
	"module_key int(11) NOT NULL default '0',
	  url mediumtext NOT NULL default '',
	  file_path varchar(20) NOT NULL default '',
	  item_count int(2) NOT NULL default '0',
	  PRIMARY KEY  (module_key),
	  KEY ModuleKeyIdx (module_key)");

	runSQL("Insert Feedreader into [DB]ModuleTypes table",
	"INSERT INTO [DB]ModuleTypes(Name,Code) VALUES ('Feedreader','feedreader')",
	"SELECT * FROM [DB]ModuleTypes WHERE Code='feedreader'");

	addColumn("QuizSettings", "AnswerAttempts tinyint(2) NOT NULL DEFAULT '0' AFTER ShowCorrect");
	addColumn("QuizSettings", "FeedbackAttempts tinyint(2) NOT NULL DEFAULT '0' AFTER ShowFeedback");
	addColumn("QTAttemptsData", "ResponseText text NOT NULL DEFAULT '' AFTER ResponseIdent");
	addColumn("posts", "unauth_name varchar(60) DEFAULT NULL after attachment");
	addColumn("posts", "unauth_email varchar(70) DEFAULT NULL AFTER unauth_name");
	addColumn("posts", "unauth_url varchar(80) DEFAULT NULL AFTER unauth_email");
	//addColumn("Pages", "PageKey int(11) NOT NULL default '0' FIRST");
	if (!$CONN->Execute("SELECT PageKey FROM {$CONFIG['DB_PREFIX']}Pages")) {
		runSQL("Add primary key to Pages table", "ALTER TABLE [DB]Pages ADD PageKey int(11) NOT NULL AUTO_INCREMENT FIRST, ADD PRIMARY KEY (PageKey)");
	}
	addColumn("Pages", "AddedByKey int(11) NOT NULL default '0' AFTER BODY");
	addColumn("Pages", "DateAdded datetime NOT NULL default '0000-00-00 00:00:00' AFTER AddedByKey");
	createTable("page_settings", 
  "module_key int(11) NOT NULL default '0',
  versions int(11) NOT NULL default '0',
  edit_rights tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (module_key)");
	//now add page settings entry for every existing page if it doesn't already have one
	$rs = $CONN->Execute("SELECT ModuleKey FROM {$CONFIG['DB_PREFIX']}Pages");
	while(!$rs->EOF) {
		if (!$CONN->GetOne("SELECT module_key FROM {$CONFIG['DB_PREFIX']}page_settings WHERE module_key='{$rs->fields[0]}'")) {
			$CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}page_settings VALUES ('{$rs->fields[0]}','1','0')");
		}
		$rs->MoveNext();	
	}
	$rs->Close();
	addColumn("Skins", "Version int(10) NOT NULL default 0 AFTER RawCss");  
	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2006121801', ReleaseName='2.3rc1'")===false) {
   		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The database version has been updated</p>';
	}	
} //end run2006121801Upgrade

function run2007052801Upgrade() {
	global $CONN, $CONFIG, $verbo, $smartnet, $general_strings;

if($verbo) echo '<span class="message">Switching to new Chat system&hellip;</span><br />';

/////////////////// NEW CHAT (for 2.4)

createTable("chat", 
  "module_key int(11) unsigned NOT NULL default '0',
  last_clean datetime default NULL,
  PRIMARY KEY  (module_key)");

createTable("chat_events",
  "id int(11) unsigned NOT NULL auto_increment,
  module_key int(11) NOT NULL default '0',
  time datetime NOT NULL default '0000-00-00 00:00:00',
  for_user text,
  data text,
  PRIMARY KEY  (id),
  KEY module_key (module_key)");

createTable("chat_users",
  "module_key int(11) unsigned NOT NULL default '0',
  user_key int(11) default NULL,
  handle varchar(20) NOT NULL default '',
  role varchar(20) NOT NULL default 'none',
  last_poll datetime default NULL,
  last_poll_id int(11) unsigned NOT NULL default '0',
  status tinyint(3) unsigned NOT NULL default '0',
  KEY module_key (module_key),
  KEY user_key (user_key)");

//setup existing chat modules in new table
if($verbo) echo '<span class="message">Transfer old chat modules&hellip;</span><br />';

if($rs=$CONN->Execute("SELECT ModuleKey FROM {$CONFIG['DB_PREFIX']}Modules WHERE ModuleTypeKey=13")) {
	while(!$rs->EOF) {
		runSQL('',"INSERT INTO [DB]chat (module_key) values ('{$rs->fields[0]}')","SELECT * FROM [DB]chat WHERE module_key='{$rs->fields[0]}'");
		$rs->MoveNext();
	}
}


if($verbo) echo '<span class="message">Drop old chat tables&hellip;</span><br />';
dropTable("ChatBanUsers");
dropTable("ChatMessages");
dropTable("ChatRegUsers");
dropTable("ChatUsers");

//for dumb windows tables:
dropTable("chatbanusers");
dropTable("chatmessages");
dropTable("chatregusers");
dropTable("chatusers");


if($verbo) echo '<span class="message">Changing Database Table Case&hellip;</span><br />';

runSQL('',"RENAME TABLE [DB]Users TO [DB]users_temp","SELECT * FROM [DB]Users",true,false);
runSQL('',"RENAME TABLE [DB]users_temp TO [DB]users","SELECT * FROM [DB]users_temp",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE UserKey user_key int(11) NOT NULL auto_increment","SELECT UserKey FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE UserName username varchar(20) NOT NULL default ''","SELECT UserName FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE Password password varchar(32) NOT NULL default ''","SELECT Password FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE UserIDNumber user_id_number varchar(20) NOT NULL default ''","SELECT UserIDNumber FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE FirstName first_name varchar(50) NOT NULL default ''","SELECT FirstName FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE LastName last_name varchar(50) NOT NULL default ''","SELECT LastName FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE PreferedName prefered_name varchar(30) NOT NULL default ''","SELECT PreferedName FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE Email email varchar(50) NOT NULL default ''","SELECT Email FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE Details details mediumtext NOT NULL","SELECT Details FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE LevelKey level_key tinyint(4) NOT NULL default '0'","SELECT LevelKey FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE Photo photo varchar(15) NOT NULL default ''","SELECT Photo FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE FilePath file_path varchar(20) NOT NULL default ''","SELECT FilePath FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE UseCount use_count int(11) NOT NULL default '0'","SELECT UseCount FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE LastUse last_use datetime NOT NULL default '0000-00-00 00:00:00'","SELECT LastUse FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE AccountStatus account_status tinyint(4) NOT NULL default '0'","SELECT AccountStatus FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE LanguageKey language_key varchar(32) NOT NULL DEFAULT ''","SELECT LanguageKey FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE AutoLoadEditor auto_load_editor tinyint(1) NOT NULL default '1'","SELECT AutoLoadEditor FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE ReadPostsFlag read_posts_flag tinyint(1) NOT NULL default '0'","SELECT ReadPostsFlag FROM [DB]users",true,false);
runSQL('',"ALTER TABLE [DB]users CHANGE SkinKey skin_key int(11) NOT NULL default '1'","SELECT SkinKey FROM [DB]users",true,false);

runSQL('',"RENAME TABLE [DB]AccessLevels TO [DB]access_levels","SELECT * FROM [DB]AccessLevels",true,false);
runSQL('',"ALTER TABLE [DB]access_levels CHANGE AccessLevelKey access_level_key tinyint(4) NOT NULL auto_increment","SELECT AccessLevelKey FROM [DB]access_levels",true,false);
runSQL('',"ALTER TABLE [DB]access_levels CHANGE Name name varchar(20) NOT NULL default ''","SELECT Name FROM [DB]access_levels",true,false);

runSQL('',"RENAME TABLE [DB]CalendarEvents TO [DB]calendar_events","SELECT * FROM [DB]CalendarEvents",true,false);
runSQL('',"ALTER TABLE [DB]calendar_events CHANGE EventKey event_key int(11) NOT NULL auto_increment","SELECT EventKey FROM [DB]calendar_events",true,false);
runSQL('',"ALTER TABLE [DB]calendar_events CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]calendar_events",true,false);
runSQL('',"ALTER TABLE [DB]calendar_events CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]calendar_events",true,false);
runSQL('',"ALTER TABLE [DB]calendar_events CHANGE Name name varchar(60) NOT NULL default ''","SELECT Name FROM [DB]calendar_events",true,false);
runSQL('',"ALTER TABLE [DB]calendar_events CHANGE Description description text NOT NULL default ''","SELECT Description FROM [DB]calendar_events",true,false);
runSQL('',"ALTER TABLE [DB]calendar_events CHANGE EventDate event_date datetime NOT NULL default '0000-00-00 00:00:00'","SELECT EventDate FROM [DB]calendar_events",true,false);
runSQL('',"ALTER TABLE [DB]calendar_events CHANGE RemoveDate remove_date datetime NOT NULL default '0000-00-00 00:00:00'","SELECT RemoveDate FROM [DB]calendar_events",true,false);
runSQL('',"ALTER TABLE [DB]calendar_events CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]calendar_events",true,false);
runSQL('',"ALTER TABLE [DB]calendar_events CHANGE EventDateFinish event_date_finish datetime NOT NULL DEFAULT '0000-00-00 00:00:00'","SELECT EventDateFinish FROM [DB]calendar_events",true,false);
runSQL('',"ALTER TABLE [DB]calendar_events CHANGE DateFlags date_flags tinyint(4) unsigned NOT NULL default '0'","SELECT DateFlags FROM [DB]calendar_events",true,false);
runSQL('',"ALTER TABLE [DB]calendar_events CHANGE Link link varchar(200) NOT NULL DEFAULT ''","SELECT Link FROM [DB]calendar_events",true,false);
runSQL('',"ALTER TABLE [DB]calendar_events CHANGE EventType event_type int UNSIGNED NOT NULL DEFAULT '0'","SELECT EventType FROM [DB]calendar_events",true,false); 

runSQL('',"RENAME TABLE [DB]Calendars TO [DB]Calendars_temp","SELECT * FROM [DB]Calendars",true,false);
runSQL('',"RENAME TABLE [DB]Calendars_temp TO [DB]calendars","SELECT * FROM [DB]Calendars_temp",true,false);
runSQL('',"ALTER TABLE [DB]calendars CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]calendars",true,false);
runSQL('',"ALTER TABLE [DB]calendars CHANGE ParentCalendarKey parent_calendar_key int(11) NOT NULL default '0'","SELECT ParentCalendarKey FROM [DB]calendars",true,false);
runSQL('',"ALTER TABLE [DB]calendars CHANGE Type type varchar(6) NOT NULL default ''","SELECT Type FROM [DB]calendars",true,false);

dropTable("Categories");
dropTable("CategoryExternalLinks");

runSQL('',"RENAME TABLE [DB]CommonNavigationLinks TO [DB]common_nav_links","SELECT * FROM [DB]CommonNavigationLinks",true,false);
runSQL('',"ALTER TABLE [DB]common_nav_links CHANGE LinkKey link_key int(11) NOT NULL default '0'","SELECT LinkKey FROM [DB]common_nav_links",true,false);
runSQL('',"ALTER TABLE [DB]common_nav_links CHANGE SpaceTypeKey space_type_key tinyint(4) NOT NULL default '0'","SELECT SpaceTypeKey FROM [DB]common_nav_links",true,false);
runSQL('',"ALTER TABLE [DB]common_nav_links CHANGE Name name varchar(50) NOT NULL default ''","SELECT Name FROM [DB]common_nav_links",true,false);
runSQL('',"ALTER TABLE [DB]common_nav_links CHANGE Url url varchar(100) NOT NULL default ''","SELECT Url FROM [DB]common_nav_links",true,false);

runSQL('',"RENAME TABLE [DB]DefaultSpaceUserLinks TO [DB]default_space_user_links","SELECT * FROM [DB]DefaultSpaceUserLinks",true,false);
runSQL('',"ALTER TABLE [DB]default_space_user_links CHANGE UserGroupKey user_group_key int(11) NOT NULL default '0'","SELECT UserGroupKey FROM [DB]default_space_user_links",true,false);
runSQL('',"ALTER TABLE [DB]default_space_user_links CHANGE SpaceKey space_key int(11) NOT NULL default '0'","SELECT SpaceKey FROM [DB]default_space_user_links",true,false);
runSQL('',"ALTER TABLE [DB]default_space_user_links CHANGE Permanent permanent tinyint(1) NOT NULL default '0'","SELECT Permanent FROM [DB]default_space_user_links",true,false);

runSQL('',"RENAME TABLE [DB]DateFormats TO [DB]date_formats","SELECT * FROM [DB]DateFormats",true,false);
runSQL('',"ALTER TABLE [DB]date_formats CHANGE FormatKey format_key int(11) NOT NULL default '0'","SELECT FormatKey FROM [DB]date_formats",true,false);
runSQL('',"ALTER TABLE [DB]date_formats CHANGE Format format varchar(15) NOT NULL default ''","SELECT Format FROM [DB]date_formats",true,false);
runSQL('',"ALTER TABLE [DB]date_formats CHANGE Type type varchar(5) NOT NULL default ''","SELECT Type FROM [DB]date_formats",true,false); 

runSQL('',"RENAME TABLE [DB]DropboxFileStatus TO [DB]dropbox_file_status","SELECT * FROM [DB]DropboxFileStatus",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_file_status CHANGE StatusKey status_key int(11) NOT NULL auto_increment","SELECT StatusKey FROM [DB]dropbox_file_status",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_file_status CHANGE Name name varchar(30) NOT NULL default ''","SELECT Name FROM [DB]dropbox_file_status",true,false);

runSQL('',"RENAME TABLE [DB]DropboxFiles TO [DB]dropbox_files","SELECT * FROM [DB]DropboxFiles",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_files CHANGE FileKey file_key int(11) NOT NULL auto_increment","SELECT FileKey FROM [DB]dropbox_files",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_files CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]dropbox_files",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_files CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]dropbox_files",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_files CHANGE GradebookItemKey gradebook_item_key int(11) NOT NULL default '0'","SELECT GradebookItemKey FROM [DB]dropbox_files",true,false); 
runSQL('',"ALTER TABLE [DB]dropbox_files CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]dropbox_files",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_files CHANGE Status status tinyint(4) NOT NULL default '0'","SELECT Status FROM [DB]dropbox_files",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_files CHANGE DateStatusChanged date_status_changed datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateStatusChanged FROM [DB]dropbox_files",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_files CHANGE Description description varchar(50) NOT NULL default ''","SELECT Description FROM [DB]dropbox_files",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_files CHANGE Comments comments text NOT NULL","SELECT Comments FROM [DB]dropbox_files",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_files CHANGE Filename filename varchar(50) NOT NULL default ''","SELECT Filename FROM [DB]dropbox_files",true,false);

runSQL('',"RENAME TABLE [DB]DropboxSettings TO [DB]dropbox_settings","SELECT * FROM [DB]DropboxSettings",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_settings CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]dropbox_settings",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_settings CHANGE FilePath file_path varchar(20) NOT NULL default ''","SELECT FilePath FROM [DB]dropbox_settings",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_settings CHANGE TypeKey type_key tinyint(1) NOT NULL default '1'","SELECT TypeKey FROM [DB]dropbox_settings",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_settings CHANGE TimeAllowed time_allowed int(4) NOT NULL default '0'","SELECT TimeAllowed FROM [DB]dropbox_settings",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_settings CHANGE DownloadFile download_file varchar(40) NOT NULL default ''","SELECT DownloadFile FROM [DB]dropbox_settings",true,false); 

runSQL('',"RENAME TABLE [DB]DropboxDownloadLinks TO [DB]dropbox_download_links","SELECT * FROM [DB]DropboxDownloadLinks",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_download_links CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]dropbox_download_links",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_download_links CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]dropbox_download_links",true,false); 
runSQL('',"ALTER TABLE [DB]dropbox_download_links CHANGE TimeDownloaded time_downloaded datetime NOT NULL default '0000-00-00 00:00:00'","SELECT TimeDownloaded FROM [DB]dropbox_download_links",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_download_links CHANGE TimeUploaded time_uploaded datetime NOT NULL default '0000-00-00 00:00:00'","SELECT TimeUploaded FROM [DB]dropbox_download_links",true,false);
runSQL('',"ALTER TABLE [DB]dropbox_download_links CHANGE Filename filename varchar(45) NOT NULL default ''","SELECT Filename FROM [DB]dropbox_download_links",true,false); 

runSQL('',"RENAME TABLE [DB]Files TO [DB]Files_temp","SELECT * FROM [DB]Files",true,false);
runSQL('',"RENAME TABLE [DB]Files_temp TO [DB]files","SELECT * FROM [DB]Files_temp",true,false);
runSQL('',"ALTER TABLE [DB]files CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]files",true,false);
runSQL('',"ALTER TABLE [DB]files CHANGE FilePath file_path varchar(50) NOT NULL default ''","SELECT FilePath FROM [DB]files",true,false);
runSQL('',"ALTER TABLE [DB]files CHANGE Filename filename varchar(50) NOT NULL default ''","SELECT Filename FROM [DB]files",true,false);
runSQL('',"ALTER TABLE [DB]files CHANGE Embedded embedded tinyint(1) NOT NULL default '0'","SELECT Embedded FROM [DB]files",true,false);

runSQL('',"RENAME TABLE [DB]FolderSettings TO [DB]folder_settings","SELECT * FROM [DB]FolderSettings",true,false);
runSQL('',"ALTER TABLE [DB]folder_settings CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]folder_settings",true,false);
runSQL('',"ALTER TABLE [DB]folder_settings CHANGE SortOrderKey sort_order_key tinyint(4) NOT NULL default '0'","SELECT SortOrderKey FROM [DB]folder_settings",true,false);
runSQL('',"ALTER TABLE [DB]folder_settings CHANGE NavigationMode navigation_mode tinyint(1) NOT NULL default '0'","SELECT NavigationMode FROM [DB]folder_settings",true,false);

runSQL('',"RENAME TABLE [DB]postsAutoPromptActions TO [DB]posts_autoprompt_actions","SELECT * FROM [DB]postsAutoPromptActions",true,false);
runSQL('',"ALTER TABLE [DB]posts_autoprompt_actions CHANGE ActionKey action_key tinyint(2) NOT NULL default '0'","SELECT ActionKey FROM [DB]posts_autoprompt_actions",true,false);
runSQL('',"ALTER TABLE [DB]posts_autoprompt_actions CHANGE Name name varchar(45) NOT NULL default ''","SELECT Name FROM [DB]posts_autoprompt_actions",true,false);

runSQL('',"RENAME TABLE [DB]postsAutoPrompts TO [DB]posts_autoprompts","SELECT * FROM [DB]postsAutoPrompts",true,false);
runSQL('',"ALTER TABLE [DB]posts_autoprompts CHANGE post_key post_key int(11) NOT NULL default '0'","SELECT post_key FROM [DB]posts_autoprompts",true,false);
runSQL('',"ALTER TABLE [DB]posts_autoprompts CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]posts_autoprompts",true,false);
runSQL('',"ALTER TABLE [DB]posts_autoprompts CHANGE DatePrompted date_prompted datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DatePrompted FROM [DB]posts_autoprompts",true,false);
runSQL('',"ALTER TABLE [DB]posts_autoprompts CHANGE DateActioned date_actioned datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateActioned FROM [DB]posts_autoprompts",true,false);
runSQL('',"ALTER TABLE [DB]posts_autoprompts CHANGE ActionTakenKey action_taken_key tinyint(2) NOT NULL default '0'","SELECT ActionTakenKey FROM [DB]posts_autoprompts",true,false);
runSQL('',"ALTER TABLE [DB]posts_autoprompts CHANGE PromptedByKey prompted_by_key int(11) NOT NULL default '0'","SELECT PromptedByKey FROM [DB]posts_autoprompts",true,false);

runSQL('',"RENAME TABLE [DB]ForumSettings TO [DB]forum_settings","SELECT * FROM [DB]ForumSettings",true,false);
runSQL('',"ALTER TABLE [DB]forum_settings CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]forum_settings",true,false);
runSQL('',"ALTER TABLE [DB]forum_settings CHANGE ForumType forum_type varchar(10) NOT NULL default ''","SELECT ForumType FROM [DB]forum_settings",true,false);
runSQL('',"ALTER TABLE [DB]forum_settings CHANGE EditLevel edit_level tinyint(4) NOT NULL default '0'","SELECT EditLevel FROM [DB]forum_settings",true,false);
runSQL('',"ALTER TABLE [DB]forum_settings CHANGE AutoPrompting auto_prompting tinyint(1) NOT NULL default '0'","SELECT AutoPrompting FROM [DB]forum_settings",true,false);
runSQL('',"ALTER TABLE [DB]forum_settings CHANGE DaysToWaitDefault days_to_wait tinyint(2) NOT NULL default '0'","SELECT DaysToWaitDefault FROM [DB]forum_settings",true,false);
runSQL('',"ALTER TABLE [DB]forum_settings CHANGE NumberToPromptDefault number_to_prompt tinyint(2) NOT NULL default '0'","SELECT NumberToPromptDefault FROM [DB]forum_settings",true,false);
runSQL('',"ALTER TABLE [DB]forum_settings CHANGE PassesAllowedDefault passes_allowed tinyint(2) NOT NULL default '0'","SELECT PassesAllowedDefault FROM [DB]forum_settings",true,false);
runSQL('',"ALTER TABLE [DB]forum_settings CHANGE ResponseTimeDefault response_time tinyint(2) NOT NULL default '0'","SELECT ResponseTimeDefault FROM [DB]forum_settings",true,false);
runSQL('',"ALTER TABLE [DB]forum_settings CHANGE MinimumRepliesDefault minimum_replies tinyint(2) NOT NULL default '0'","SELECT MinimumRepliesDefault FROM [DB]forum_settings",true,false);
runSQL('',"ALTER TABLE [DB]forum_settings CHANGE FilePath file_path varchar(20) NOT NULL default ''","SELECT FilePath FROM [DB]forum_settings",true,false);

runSQL('',"RENAME TABLE [DB]ForumThreadManagement TO [DB]forum_thread_management","SELECT * FROM [DB]ForumThreadManagement",true,false);
runSQL('',"ALTER TABLE [DB]forum_thread_management CHANGE PostKey post_key int(11) NOT NULL default '0'","SELECT PostKey FROM [DB]forum_thread_management",true,false);
runSQL('',"ALTER TABLE [DB]forum_thread_management CHANGE DaysToWait days_to_wait tinyint(2) NOT NULL default '0'","SELECT DaysToWait FROM [DB]forum_thread_management",true,false);
runSQL('',"ALTER TABLE [DB]forum_thread_management CHANGE NumberToPrompt number_to_prompt tinyint(2) NOT NULL default '0'","SELECT NumberToPrompt FROM [DB]forum_thread_management",true,false);
runSQL('',"ALTER TABLE [DB]forum_thread_management CHANGE PassesAllowed passes_allowed tinyint(2) NOT NULL default '0'","SELECT PassesAllowed FROM [DB]forum_thread_management",true,false);
runSQL('',"ALTER TABLE [DB]forum_thread_management CHANGE ResponseTime response_time tinyint(2) NOT NULL default '0'","SELECT ResponseTime FROM [DB]forum_thread_management",true,false);
runSQL('',"ALTER TABLE [DB]forum_thread_management CHANGE MinimumReplies minimum_replies tinyint(2) NOT NULL default '0'","SELECT MinimumReplies FROM [DB]forum_thread_management",true,false);

runSQL('',"RENAME TABLE [DB]GradebookItems TO [DB]gradebook_items","SELECT * FROM [DB]GradebookItems",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE ItemKey item_key int(11) NOT NULL auto_increment","SELECT ItemKey FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE ScaleKey scale_key int(11) NOT NULL default '0'","SELECT ScaleKey FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE Name name varchar(100) NOT NULL default ''","SELECT Name FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE Description description varchar(255) NOT NULL default ''","SELECT Description FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE Url url varchar(150) NOT NULL default ''","SELECT Url FROM [DB]gradebook_items",true,false); 
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE ContentModuleKey content_module_key int(11) NOT NULL default '0'","SELECT ContentModuleKey FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE StatusKey status_key tinyint(1) NOT NULL default '0'","SELECT StatusKey FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE SortOrder sort_order tinyint(3) NOT NULL default '0'","SELECT SortOrder FROM [DB]gradebook_items",true,false); 
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE DueDate due_date datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DueDate FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE MaximumScore maximum_score tinyint(3) NOT NULL default '0'","SELECT MaximumScore FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE Weighting weighting tinyint(3) NOT NULL default '0'","SELECT Weighting FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE AddedByKey added_by_key int(11) NOT NULL default '0'","SELECT AddedByKey FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE ModifiedByKey modified_by_key int(11) NOT NULL default '0'","SELECT ModifiedByKey FROM [DB]gradebook_items",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_items CHANGE DateModified date_modified datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateModified FROM [DB]gradebook_items",true,false);

runSQL('',"RENAME TABLE [DB]GradebookItemUserLinks TO [DB]gradebook_item_user_links","SELECT * FROM [DB]GradebookItemUserLinks",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_item_user_links CHANGE ItemKey item_key int(11) NOT NULL auto_increment","SELECT ItemKey FROM [DB]gradebook_item_user_links",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_item_user_links CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]gradebook_item_user_links",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_item_user_links CHANGE AddedByKey added_by_key int(11) NOT NULL default '0'","SELECT AddedByKey FROM [DB]gradebook_item_user_links",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_item_user_links CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]gradebook_item_user_links",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_item_user_links CHANGE ModifiedByKey modified_by_key int(11) NOT NULL default '0'","SELECT ModifiedByKey FROM [DB]gradebook_item_user_links",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_item_user_links CHANGE DateModified date_modified datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateModified FROM [DB]gradebook_item_user_links",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_item_user_links CHANGE GradeKey grade_key int(3) NOT NULL default '0'","SELECT GradeKey FROM [DB]gradebook_item_user_links",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_item_user_links CHANGE Comments comments mediumtext NOT NULL","SELECT Comments FROM [DB]gradebook_item_user_links",true,false);

runSQL('',"RENAME TABLE [DB]GradebookScales TO [DB]gradebook_scales","SELECT * FROM [DB]GradebookScales",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scales CHANGE ScaleKey scale_key int(11) NOT NULL auto_increment","SELECT ScaleKey FROM [DB]gradebook_scales",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scales CHANGE Name name varchar(100) NOT NULL default ''","SELECT Name FROM [DB]gradebook_scales",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scales CHANGE Description description text NOT NULL default ''","SELECT Description FROM [DB]gradebook_scales",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scales CHANGE SpaceKey space_key int(11) NOT NULL default '0'","SELECT SpaceKey FROM [DB]gradebook_scales",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scales CHANGE AddedByKey added_by_key int(11) NOT NULL default '0'","SELECT AddedByKey FROM [DB]gradebook_scales",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scales CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]gradebook_scales",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scales CHANGE ModifiedByKey modified_by_key int(11) NOT NULL default '0'","SELECT ModifiedByKey FROM [DB]gradebook_scales",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scales CHANGE DateModified date_modified datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateModified FROM [DB]gradebook_scales",true,false);

runSQL('',"RENAME TABLE [DB]GradebookScaleGrades TO [DB]gradebook_scale_grades","SELECT * FROM [DB]GradebookScaleGrades",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scale_grades CHANGE GradeKey grade_key int(11) NOT NULL auto_increment","SELECT GradeKey FROM [DB]gradebook_scale_grades",true,false); 
runSQL('',"ALTER TABLE [DB]gradebook_scale_grades CHANGE ScaleKey scale_key int(11) NOT NULL default '0'","SELECT ScaleKey FROM [DB]gradebook_scale_grades",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scale_grades CHANGE Grade grade varchar(255) NOT NULL default ''","SELECT Grade FROM [DB]gradebook_scale_grades",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scale_grades CHANGE AddedByKey added_by_key int(11) NOT NULL default '0'","SELECT AddedByKey FROM [DB]gradebook_scale_grades",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scale_grades CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]gradebook_scale_grades",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scale_grades CHANGE ModifiedByKey modified_by_key int(11) NOT NULL default '0'","SELECT ModifiedByKey FROM [DB]gradebook_scale_grades",true,false);
runSQL('',"ALTER TABLE [DB]gradebook_scale_grades CHANGE DateModified date_modified datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateModified FROM [DB]gradebook_scale_grades",true,false);

runSQL('',"RENAME TABLE [DB]GroupSettings TO [DB]group_settings","SELECT * FROM [DB]GroupSettings",true,false);
runSQL('',"ALTER TABLE [DB]group_settings CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]group_settings",true,false);
runSQL('',"ALTER TABLE [DB]group_settings CHANGE SortOrderKey sort_order_key tinyint(4) NOT NULL default '0'","SELECT SortOrderKey FROM [DB]group_settings",true,false);
runSQL('',"ALTER TABLE [DB]group_settings CHANGE AccessKey access_key tinyint(4) NOT NULL default '0'","SELECT AccessKey FROM [DB]group_settings",true,false);
runSQL('',"ALTER TABLE [DB]group_settings CHANGE AccessCode access_code varchar(10) NOT NULL default ''","SELECT AccessCode FROM [DB]group_settings",true,false);
runSQL('',"ALTER TABLE [DB]group_settings CHANGE VisibilityKey visibility_key tinyint(4) NOT NULL default '0'","SELECT VisibilityKey FROM [DB]group_settings",true,false);
runSQL('',"ALTER TABLE [DB]group_settings CHANGE MaximumUsers maximum_users tinyint(4) NOT NULL default '0'","SELECT MaximumUsers FROM [DB]group_settings",true,false);
runSQL('',"ALTER TABLE [DB]group_settings CHANGE MinimumUsers minimum_users tinyint(4) NOT NULL default '0'","SELECT MinimumUsers FROM [DB]group_settings",true,false);
runSQL('',"ALTER TABLE [DB]group_settings CHANGE StartDate start_date DateTime NOT NULL default '0000-00-00'","SELECT StartDate FROM [DB]group_settings",true,false);
runSQL('',"ALTER TABLE [DB]group_settings CHANGE FinishDate finish_date DateTime NOT NULL default '0000-00-00'","SELECT FinishDate FROM [DB]group_settings",true,false);
runSQL('',"ALTER TABLE [DB]group_settings CHANGE GroupManagement group_management tinyint(1) NOT NULL default '0'","SELECT GroupManagement FROM [DB]group_settings",true,false);

runSQL('',"RENAME TABLE [DB]GroupUserLinks TO [DB]group_user_links","SELECT * FROM [DB]GroupUserLinks",true,false);
runSQL('',"ALTER TABLE [DB]group_user_links CHANGE GroupKey group_key int(11) NOT NULL default '0'","SELECT GroupKey FROM [DB]group_user_links",true,false);
runSQL('',"ALTER TABLE [DB]group_user_links CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]group_user_links",true,false);
runSQL('',"ALTER TABLE [DB]group_user_links CHANGE AccessLevelKey access_level_key tinyint(4) NOT NULL default '0'","SELECT AccessLevelKey FROM [DB]group_user_links",true,false);
runSQL('',"ALTER TABLE [DB]group_user_links CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]group_user_links",true,false);

runSQL('',"RENAME TABLE [DB]Icons TO [DB]Icons_temp","SELECT * FROM [DB]Icons",true,false);
runSQL('',"RENAME TABLE [DB]Icons_temp TO [DB]icons","SELECT * FROM [DB]Icons_temp",true,false);
runSQL('',"ALTER TABLE [DB]icons CHANGE IconKey icon_key int(11) NOT NULL auto_increment","SELECT IconKey FROM [DB]icons",true,false);
runSQL('',"ALTER TABLE [DB]icons CHANGE Name name varchar(30) NOT NULL default ''","SELECT Name FROM [DB]icons",true,false);
runSQL('',"ALTER TABLE [DB]icons CHANGE Description description varchar(255) NOT NULL default ''","SELECT Description FROM [DB]icons",true,false); 
runSQL('',"ALTER TABLE [DB]icons CHANGE SmallIcon small_icon varchar(30) NOT NULL default ''","SELECT SmallIcon FROM [DB]icons",true,false);
runSQL('',"ALTER TABLE [DB]icons CHANGE LargeIcon large_icon varchar(30) NOT NULL default ''","SELECT LargeIcon FROM [DB]icons",true,false);

runSQL('',"RENAME TABLE [DB]KBSettings TO [DB]kb_settings","SELECT * FROM [DB]KBSettings",true,false);
runSQL('',"ALTER TABLE [DB]kb_settings CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]kb_settings",true,false);
runSQL('',"ALTER TABLE [DB]kb_settings CHANGE AccessLevelKey access_level_key tinyint(4) NOT NULL default '0'","SELECT AccessLevelKey FROM [DB]kb_settings",true,false);
runSQL('',"ALTER TABLE [DB]kb_settings CHANGE FilePath file_path varchar(50) NOT NULL default ''","SELECT FilePath FROM [DB]kb_settings",true,false);

runSQL('',"RENAME TABLE [DB]KBCategories TO [DB]kb_categories","SELECT * FROM [DB]KBCategories",true,false);
runSQL('',"ALTER TABLE [DB]kb_categories CHANGE CategoryKey category_key int(11) NOT NULL auto_increment","SELECT CategoryKey FROM [DB]kb_categories",true,false);
runSQL('',"ALTER TABLE [DB]kb_categories CHANGE ParentKey parent_key int(11) NOT NULL default '0'","SELECT ParentKey FROM [DB]kb_categories",true,false);
runSQL('',"ALTER TABLE [DB]kb_categories CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]kb_categories",true,false); 
runSQL('',"ALTER TABLE [DB]kb_categories CHANGE Name name varchar(255) NOT NULL default ''","SELECT Name FROM [DB]kb_categories",true,false);

runSQL('',"RENAME TABLE [DB]KBTemplates TO [DB]kb_templates","SELECT * FROM [DB]KBTemplates",true,false);
runSQL('',"ALTER TABLE [DB]kb_templates CHANGE TemplateKey template_key int(11) NOT NULL auto_increment","SELECT TemplateKey FROM [DB]kb_templates",true,false);
runSQL('',"ALTER TABLE [DB]kb_templates CHANGE TypeKey type_key tinyint(1) NOT NULL default '0'","SELECT TypeKey FROM [DB]kb_templates",true,false);
runSQL('',"ALTER TABLE [DB]kb_templates CHANGE Name name varchar(100) NOT NULL default ''","SELECT Name FROM [DB]kb_templates",true,false);
runSQL('',"ALTER TABLE [DB]kb_templates CHANGE Description description varchar(255) NOT NULL default ''","SELECT Description FROM [DB]kb_templates",true,false);
runSQL('',"ALTER TABLE [DB]kb_templates CHANGE SummaryFields summary_fields tinyint(1) NOT NULL default '1'","SELECT SummaryFields FROM [DB]kb_templates",true,false); 
runSQL('',"ALTER TABLE [DB]kb_templates CHANGE AddedByKey added_by_key int(11) NOT NULL default '0'","SELECT AddedByKey FROM [DB]kb_templates",true,false);
runSQL('',"ALTER TABLE [DB]kb_templates CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]kb_templates",true,false);
runSQL('',"ALTER TABLE [DB]kb_templates CHANGE ModifiedByKey modified_by_key int(11) NOT NULL default '0'","SELECT ModifiedByKey FROM [DB]kb_templates",true,false);
runSQL('',"ALTER TABLE [DB]kb_templates CHANGE DateModified date_modified datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateModified FROM [DB]kb_templates",true,false);

runSQL('',"RENAME TABLE [DB]KBEntries TO [DB]kb_entries","SELECT * FROM [DB]KBEntries",true,false);
runSQL('',"ALTER TABLE [DB]kb_entries CHANGE EntryKey entry_key int(11) NOT NULL auto_increment","SELECT EntryKey FROM [DB]kb_entries",true,false);
runSQL('',"ALTER TABLE [DB]kb_entries CHANGE TemplateKey template_key int(11) NOT NULL default '0'","SELECT TemplateKey FROM [DB]kb_entries",true,false);
runSQL('',"ALTER TABLE [DB]kb_entries CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]kb_entries",true,false);
runSQL('',"ALTER TABLE [DB]kb_entries CHANGE AddedByKey added_by_key int(11) NOT NULL default '0'","SELECT AddedByKey FROM [DB]kb_entries",true,false);
runSQL('',"ALTER TABLE [DB]kb_entries CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]kb_entries",true,false);
runSQL('',"ALTER TABLE [DB]kb_entries CHANGE ModifiedByKey modified_by_key int(11) NOT NULL default '0'","SELECT ModifiedByKey FROM [DB]kb_entries",true,false);
runSQL('',"ALTER TABLE [DB]kb_entries CHANGE DateModified date_modified datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateModified FROM [DB]kb_entries",true,false);
runSQL('',"ALTER TABLE [DB]kb_entries CHANGE StatusKey status_key tinyint(1) NOT NULL default '2'","SELECT StatusKey FROM [DB]kb_entries",true,false);

runSQL('',"RENAME TABLE [DB]KBEntryData TO [DB]kb_entry_data","SELECT * FROM [DB]KBEntryData",true,false);
runSQL('',"ALTER TABLE [DB]kb_entry_data CHANGE DataKey data_key int(11) NOT NULL auto_increment","SELECT DataKey FROM [DB]kb_entry_data",true,false);
runSQL('',"ALTER TABLE [DB]kb_entry_data CHANGE EntryKey entry_key int(11) NOT NULL default '0'","SELECT EntryKey FROM [DB]kb_entry_data",true,false);
runSQL('',"ALTER TABLE [DB]kb_entry_data CHANGE FieldKey field_key tinyint(11) NOT NULL default '0'","SELECT FieldKey FROM [DB]kb_entry_data",true,false);
runSQL('',"ALTER TABLE [DB]kb_entry_data CHANGE Data data text not null default ''","SELECT Data FROM [DB]kb_entry_data",true,false);

runSQL('',"RENAME TABLE [DB]KBModuleTemplateLinks TO [DB]kb_module_template_links","SELECT * FROM [DB]KBModuleTemplateLinks",true,false);
runSQL('',"ALTER TABLE [DB]kb_module_template_links CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]kb_module_template_links",true,false);
runSQL('',"ALTER TABLE [DB]kb_module_template_links CHANGE TemplateKey template_key int(11) NOT NULL default '0'","SELECT TemplateKey FROM [DB]kb_module_template_links",true,false);

runSQL('',"RENAME TABLE [DB]KBEntryCategoryLinks TO [DB]kb_entry_category_links","SELECT * FROM [DB]KBEntryCategoryLinks",true,false);
runSQL('',"ALTER TABLE [DB]kb_entry_category_links CHANGE EntryKey entry_key int(11) NOT NULL default '0'","SELECT EntryKey FROM [DB]kb_entry_category_links",true,false);
runSQL('',"ALTER TABLE [DB]kb_entry_category_links CHANGE CategoryKey category_key int(11) NOT NULL default '0'","SELECT CategoryKey FROM [DB]kb_entry_category_links",true,false);

runSQL('',"RENAME TABLE [DB]KBFields TO [DB]kb_fields","SELECT * FROM [DB]KBFields",true,false);
runSQL('',"ALTER TABLE [DB]kb_fields CHANGE FieldKey field_key int(11) NOT NULL auto_increment","SELECT FieldKey FROM [DB]kb_fields",true,false);
runSQL('',"ALTER TABLE [DB]kb_fields CHANGE TemplateKey template_key int(11) NOT NULL default '0'","SELECT TemplateKey FROM [DB]kb_fields",true,false);
runSQL('',"ALTER TABLE [DB]kb_fields CHANGE TypeKey type_key tinyint(1) NOT NULL default '0'","SELECT TypeKey FROM [DB]kb_fields",true,false);
runSQL('',"ALTER TABLE [DB]kb_fields CHANGE Name name varchar(50) NOT NULL default ''","SELECT Name FROM [DB]kb_fields",true,false);
runSQL('',"ALTER TABLE [DB]kb_fields CHANGE Description description varchar(255) NOT NULL default ''","SELECT Description FROM [DB]kb_fields",true,false);
runSQL('',"ALTER TABLE [DB]kb_fields CHANGE DisplayOrder display_order tinyint(2) NOT NULL default '0'","SELECT DisplayOrder FROM [DB]kb_fields",true,false);
runSQL('',"ALTER TABLE [DB]kb_fields CHANGE NumberOfLines number_of_lines tinyint(2) NOT NULL default '0'","SELECT NumberOfLines FROM [DB]kb_fields",true,false);
runSQL('',"ALTER TABLE [DB]kb_fields CHANGE AddedByKey added_by_key int(11) NOT NULL default '0'","SELECT AddedByKey FROM [DB]kb_fields",true,false);
runSQL('',"ALTER TABLE [DB]kb_fields CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]kb_fields",true,false);
runSQL('',"ALTER TABLE [DB]kb_fields CHANGE ModifiedByKey modified_by_key int(11) NOT NULL default '0'","SELECT ModifiedByKey FROM [DB]kb_fields",true,false);
runSQL('',"ALTER TABLE [DB]kb_fields CHANGE DateModified date_modified datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateModified FROM [DB]kb_fields",true,false); 

runSQL('',"RENAME TABLE [DB]ModuleEditRightLinks TO [DB]module_edit_right_links","SELECT * FROM [DB]ModuleEditRightLinks",true,false);
runSQL('',"ALTER TABLE [DB]module_edit_right_links CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]module_edit_right_links",true,false);
runSQL('',"ALTER TABLE [DB]module_edit_right_links CHANGE GroupKey group_key int(11) NOT NULL default '0'","SELECT GroupKey FROM [DB]module_edit_right_links",true,false);
runSQL('',"ALTER TABLE [DB]module_edit_right_links CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]module_edit_right_links",true,false);
runSQL('',"ALTER TABLE [DB]module_edit_right_links CHANGE LinkKey link_key int(11) NOT NULL default '0'","SELECT LinkKey FROM [DB]module_edit_right_links",true,false);
runSQL('',"ALTER TABLE [DB]module_edit_right_links CHANGE EditLevel edit_level tinyint(4) NOT NULL default '0'","SELECT EditLevel FROM [DB]module_edit_right_links",true,false); 

runSQL('',"RENAME TABLE [DB]ModuleSpaceLinks TO [DB]module_space_links","SELECT * FROM [DB]ModuleSpaceLinks",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE LinkKey link_key int(11) NOT NULL auto_increment","SELECT LinkKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE SpaceKey space_key int(11) NOT NULL default '0'","SELECT SpaceKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE ParentKey parent_key int(11) NOT NULL default '0'","SELECT ParentKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE BlockKey block_key tinyint(2) NOT NULL default '0'","SELECT BlockKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE GroupKey group_key int(11) NOT NULL default '0'","SELECT GroupKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE StatusKey status_key tinyint(4) NOT NULL default '0'","SELECT StatusKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE AccessLevelKey access_level_key int(11) NOT NULL default '0'","SELECT AccessLevelKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE IconKey icon_key int(11) NOT NULL default '1'","SELECT IconKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE AddedByKey added_by_key int(11) NOT NULL default '0'","SELECT AddedByKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE OwnerKey owner_key int(11) NOT NULL default '0'","SELECT OwnerKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE ModifiedByKey modified_by_key int(11) NOT NULL default '0'","SELECT ModifiedByKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE DateModified date_modified datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateModified FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE EditRightsKey edit_rights_key tinyint(2) NOT NULL default '0'","SELECT EditRightsKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE ChangeStatusDate change_status_date date NOT NULL default '0000-00-00'","SELECT ChangeStatusDate FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE ChangeStatusToKey change_status_to_key int(11) NOT NULL default '0'","SELECT ChangeStatusToKey FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE SortOrder sort_order mediumint(4) NOT NULL default '0'","SELECT SortOrder FROM [DB]module_space_links",true,false);
runSQL('',"ALTER TABLE [DB]module_space_links CHANGE Target target varchar(10) NOT NULL default ''","SELECT Target FROM [DB]module_space_links",true,false);

runSQL('',"RENAME TABLE [DB]ModuleTypes TO [DB]module_types","SELECT * FROM [DB]ModuleTypes",true,false);
runSQL('',"ALTER TABLE [DB]module_types CHANGE ModuleTypeKey module_type_key int(11) NOT NULL auto_increment","SELECT ModuleTypeKey FROM [DB]module_types",true,false);
runSQL('',"ALTER TABLE [DB]module_types CHANGE Name name varchar(30) NOT NULL default ''","SELECT Name FROM [DB]module_types",true,false);
runSQL('',"ALTER TABLE [DB]module_types CHANGE Code code varchar(15) NOT NULL default ''","SELECT Code FROM [DB]module_types",true,false);
runSQL('',"ALTER TABLE [DB]module_types CHANGE Url url varchar(50) NOT NULL default ''","SELECT Url FROM [DB]module_types",true,false);
runSQL('',"ALTER TABLE [DB]module_types CHANGE AdminUrl admin_url varchar(40) NOT NULL default ''","SELECT AdminUrl FROM [DB]module_types",true,false);
runSQL('',"ALTER TABLE [DB]module_types CHANGE Image image varchar(15) NOT NULL default ''","SELECT Image FROM [DB]module_types",true,false);

runSQL('',"RENAME TABLE [DB]Modules TO [DB]Modules_temp","SELECT * FROM [DB]Modules",true,false);
runSQL('',"RENAME TABLE [DB]Modules_temp TO [DB]modules","SELECT * FROM [DB]Modules_temp",true,false);
runSQL('',"ALTER TABLE [DB]modules CHANGE ModuleKey module_key int(11) NOT NULL auto_increment","SELECT ModuleKey FROM [DB]modules",true,false);
runSQL('',"ALTER TABLE [DB]modules CHANGE ModuleTypeKey module_type_key int(11) NOT NULL default '0'","SELECT ModuleTypeKey FROM [DB]modules",true,false);
runSQL('',"ALTER TABLE [DB]modules CHANGE StatusKey status_key tinyint(4) NOT NULL default '1'","SELECT StatusKey FROM [DB]modules",true,false);
runSQL('',"ALTER TABLE [DB]modules CHANGE Name name varchar(100) NOT NULL default ''","SELECT Name FROM [DB]modules",true,false);
runSQL('',"ALTER TABLE [DB]modules CHANGE Description description text NOT NULL default ''","SELECT Description FROM [DB]modules",true,false);
runSQL('',"ALTER TABLE [DB]modules CHANGE AddedByKey added_by_key int(11) NOT NULL default '0'","SELECT AddedByKey FROM [DB]modules",true,false);
runSQL('',"ALTER TABLE [DB]modules CHANGE OwnerKey owner_key int(11) NOT NULL default '0'","SELECT OwnerKey FROM [DB]modules",true,false);
runSQL('',"ALTER TABLE [DB]modules CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]modules",true,false);
runSQL('',"ALTER TABLE [DB]modules CHANGE ModifiedByKey modified_by_key int(11) NOT NULL default '0'","SELECT ModifiedByKey FROM [DB]modules",true,false);
runSQL('',"ALTER TABLE [DB]modules CHANGE DateModified date_modified datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateModified FROM [DB]modules",true,false);
runSQL('',"ALTER TABLE [DB]modules CHANGE EditRightsKey edit_rights_key tinyint(2) NOT NULL default '0'","SELECT EditRightsKey FROM [DB]modules",true,false);

runSQL('',"RENAME TABLE [DB]News TO [DB]News_temp","SELECT * FROM [DB]News",true,false);
runSQL('',"RENAME TABLE [DB]News_temp TO [DB]news","SELECT * FROM [DB]News_temp",true,false);
runSQL('',"ALTER TABLE [DB]news CHANGE NewsKey news_key int(11) NOT NULL auto_increment","SELECT NewsKey FROM [DB]news",true,false);
runSQL('',"ALTER TABLE [DB]news CHANGE SpaceKey space_key int(11) NOT NULL default '0'","SELECT SpaceKey FROM [DB]news",true,false);
runSQL('',"ALTER TABLE [DB]news CHANGE Heading heading varchar(60) NOT NULL default ''","SELECT Heading FROM [DB]news",true,false);
runSQL('',"ALTER TABLE [DB]news CHANGE Body body text NOT NULL","SELECT Body FROM [DB]news",true,false);
runSQL('',"ALTER TABLE [DB]news CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]news",true,false);
runSQL('',"ALTER TABLE [DB]news CHANGE RemoveDate remove_date date NOT NULL default '0000-00-00'","SELECT RemoveDate FROM [DB]news",true,false);
runSQL('',"ALTER TABLE [DB]news CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]news",true,false);

runSQL('',"RENAME TABLE [DB]Notes TO [DB]Notes_temp","SELECT * FROM [DB]Notes",true,false);
runSQL('',"RENAME TABLE [DB]Notes_temp TO [DB]notes","SELECT * FROM [DB]Notes_temp",true,false);
runSQL('',"ALTER TABLE [DB]notes CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]notes",true,false);
runSQL('',"ALTER TABLE [DB]notes CHANGE Note note mediumtext NOT NULL","SELECT Note FROM [DB]notes",true,false);

runSQL('',"RENAME TABLE [DB]NoticeboardSettings TO [DB]noticeboard_settings","SELECT * FROM [DB]NoticeboardSettings",true,false);
runSQL('',"ALTER TABLE [DB]noticeboard_settings CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]noticeboard_settings",true,false);
runSQL('',"ALTER TABLE [DB]noticeboard_settings CHANGE TypeKey type_key tinyint(4) NOT NULL default '0'","SELECT TypeKey FROM [DB]noticeboard_settings",true,false);
runSQL('',"ALTER TABLE [DB]noticeboard_settings CHANGE DaysToKeep days_to_keep tinyint(2) NOT NULL default '0'","SELECT DaysToKeep FROM [DB]noticeboard_settings",true,false); 

runSQL('',"RENAME TABLE [DB]Notices TO [DB]Notices_temp","SELECT * FROM [DB]Notices",true,false);
runSQL('',"RENAME TABLE [DB]Notices_temp TO [DB]notices","SELECT * FROM [DB]Notices_temp",true,false);
runSQL('',"ALTER TABLE [DB]notices CHANGE NoticeKey notice_key int(11) NOT NULL auto_increment","SELECT NoticeKey FROM [DB]notices",true,false);
runSQL('',"ALTER TABLE [DB]notices CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]notices",true,false);
runSQL('',"ALTER TABLE [DB]notices CHANGE Heading heading varchar(60) NOT NULL default ''","SELECT Heading FROM [DB]notices",true,false);
runSQL('',"ALTER TABLE [DB]notices CHANGE Body body text NOT NULL","SELECT Body FROM [DB]notices",true,false);
runSQL('',"ALTER TABLE [DB]notices CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]notices",true,false);
runSQL('',"ALTER TABLE [DB]notices CHANGE RemoveDate remove_date date NOT NULL default '0000-00-00'","SELECT RemoveDate FROM [DB]notices",true,false);
runSQL('',"ALTER TABLE [DB]notices CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]notices",true,false);

runSQL('',"RENAME TABLE [DB]Numbers TO [DB]Numbers_temp","SELECT * FROM [DB]Numbers",true,false);
runSQL('',"RENAME TABLE [DB]Numbers_temp TO [DB]numbers","SELECT * FROM [DB]Numbers_temp",true,false);
runSQL('',"ALTER TABLE [DB]numbers CHANGE NumberKey number_key tinyint(4) NOT NULL auto_increment","SELECT NumberKey FROM [DB]numbers",true,false);
runSQL('',"ALTER TABLE [DB]numbers CHANGE Number number int(10) NOT NULL default '0'","SELECT Number FROM [DB]numbers",true,false);

runSQL('',"RENAME TABLE [DB]Pages TO [DB]Pages_temp","SELECT * FROM [DB]Pages",true,false);
runSQL('',"RENAME TABLE [DB]Pages_temp TO [DB]pages","SELECT * FROM [DB]Pages_temp",true,false);
runSQL('',"ALTER TABLE [DB]pages CHANGE PageKey page_key int(11) NOT NULL auto_increment","SELECT PageKey FROM [DB]pages",true,false); 
runSQL('',"ALTER TABLE [DB]pages CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]pages",true,false);
runSQL('',"ALTER TABLE [DB]pages CHANGE Body body longtext NOT NULL","SELECT Body FROM [DB]pages",true,false);
runSQL('',"ALTER TABLE [DB]pages CHANGE AddedByKey added_by_key int(11) NOT NULL default '0'","SELECT AddedByKey FROM [DB]pages",true,false);
runSQL('',"ALTER TABLE [DB]pages CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]pages",true,false);

runSQL('',"RENAME TABLE [DB]PostType TO [DB]post_type","SELECT * FROM [DB]PostType",true,false);
runSQL('',"ALTER TABLE [DB]post_type CHANGE TypeKey type_key int(11) NOT NULL auto_increment","SELECT TypeKey FROM [DB]post_type",true,false);
runSQL('',"ALTER TABLE [DB]post_type CHANGE Name name varchar(100) NOT NULL default ''","SELECT Name FROM [DB]post_type",true,false);

runSQL('',"RENAME TABLE [DB]QuizSettings TO [DB]quiz_settings","SELECT * FROM [DB]QuizSettings",true,false);
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE ModuleKey module_key int(11) NOT NULL auto_increment","SELECT ModuleKey FROM [DB]quiz_settings",true,false);
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE TypeKey type_key tinyint(2) NOT NULL default '0'","SELECT TypeKey FROM [DB]quiz_settings",true,false);
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE OpenDate open_date datetime NOT NULL default '0000-00-00 00:00:00'","SELECT OpenDate FROM [DB]quiz_settings",true,false);
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE CloseDate close_date datetime NOT NULL default '0000-00-00 00:00:00'","SELECT CloseDate FROM [DB]quiz_settings",true,false);
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE Attempts attempts tinyint(2) NOT NULL default '0'","SELECT Attempts FROM [DB]quiz_settings",true,false);
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE ShuffleQuestions shuffle_questions tinyint(1) NOT NULL default '0'","SELECT ShuffleQuestions FROM [DB]quiz_settings",true,false);
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE ShuffleAnswers shuffle_answers tinyint(1) NOT NULL default '0'","SELECT ShuffleAnswers FROM [DB]quiz_settings",true,false); 
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE GradingKey grading_key tinyint(2) NOT NULL default '0'","SELECT GradingKey FROM [DB]quiz_settings",true,false);
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE BuildOnPrevious build_on_previous tinyint(1) NOT NULL default '0'","SELECT BuildOnPrevious FROM [DB]quiz_settings",true,false);
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE ShowFeedback show_feedback tinyint(1) NOT NULL default '0'","SELECT ShowFeedback FROM [DB]quiz_settings",true,false); 
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE FeedbackAttempts feedback_attempts tinyint(2) NOT NULL default '0'","SELECT FeedbackAttempts FROM [DB]quiz_settings",true,false);
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE ShowCorrect show_correct tinyint(1) NOT NULL default '0'","SELECT ShowCorrect FROM [DB]quiz_settings",true,false);
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE AnswerAttempts answer_attempts tinyint(2) NOT NULL default '0'","SELECT AnswerAttempts FROM [DB]quiz_settings",true,false);
runSQL('',"ALTER TABLE [DB]quiz_settings CHANGE MinutesAllowed minutes_allowed int(3) NOT NULL default '0'","SELECT MinutesAllowed FROM [DB]quiz_settings",true,false);

runSQL('',"RENAME TABLE [DB]QTItem TO [DB]qt_item","SELECT * FROM [DB]QTItem",true,false);
runSQL('',"ALTER TABLE [DB]qt_item CHANGE ItemKey item_key int(11) NOT NULL auto_increment","SELECT ItemKey FROM [DB]qt_item",true,false);
runSQL('',"ALTER TABLE [DB]qt_item CHANGE Name name varchar(255) NOT NULL default ''","SELECT Name FROM [DB]qt_item",true,false);
runSQL('',"ALTER TABLE [DB]qt_item CHANGE Mattext mattext text NOT NULL default ''","SELECT Mattext FROM [DB]qt_item",true,false);
runSQL('',"ALTER TABLE [DB]qt_item CHANGE ResponseType response_type varchar(5) NOT NULL default ''","SELECT ResponseType FROM [DB]qt_item",true,false);
runSQL('',"ALTER TABLE [DB]qt_item CHANGE RenderType render_type varchar(20) NOT NULL default ''","SELECT RenderType FROM [DB]qt_item",true,false);
runSQL('',"ALTER TABLE [DB]qt_item CHANGE Rcardinality rcardinality varchar(10) NOT NULL default ''","SELECT Rcardinality FROM [DB]qt_item",true,false);
runSQL('',"ALTER TABLE [DB]qt_item CHANGE Rtiming rtiming varchar(3) NOT NULL default ''","SELECT Rtiming FROM [DB]qt_item",true,false);
runSQL('',"ALTER TABLE [DB]qt_item CHANGE AddedByKey added_by_key int(11) NOT NULL default '0'","SELECT AddedByKey FROM [DB]qt_item",true,false);
runSQL('',"ALTER TABLE [DB]qt_item CHANGE ModifiedByKey modified_by_key int(11) NOT NULL default '0'","SELECT ModifiedByKey FROM [DB]qt_item",true,false); 
runSQL('',"ALTER TABLE [DB]qt_item CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]qt_item",true,false);
runSQL('',"ALTER TABLE [DB]qt_item CHANGE DateModified date_modified datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateModified FROM [DB]qt_item",true,false); 

runSQL('',"RENAME TABLE [DB]QTResponse TO [DB]qt_response","SELECT * FROM [DB]QTResponse",true,false);
runSQL('',"ALTER TABLE [DB]qt_response CHANGE ItemKey item_key int(11) NOT NULL default '0'","SELECT ItemKey FROM [DB]qt_response",true,false);
runSQL('',"ALTER TABLE [DB]qt_response CHANGE Mattext mattext text NOT NULL default ''","SELECT Mattext FROM [DB]qt_response",true,false);
runSQL('',"ALTER TABLE [DB]qt_response CHANGE Ident ident varchar(100) NOT NULL default ''","SELECT Ident FROM [DB]qt_response",true,false); 

runSQL('',"RENAME TABLE [DB]QTResprocessing TO [DB]qt_resprocessing","SELECT * FROM [DB]QTResprocessing",true,false);
runSQL('',"ALTER TABLE [DB]qt_resprocessing CHANGE ItemKey item_key int(11) NOT NULL default '0'","SELECT ItemKey FROM [DB]qt_resprocessing",true,false);
runSQL('',"ALTER TABLE [DB]qt_resprocessing CHANGE ResponseIdent response_ident varchar(100) NOT NULL default ''","SELECT ResponseIdent FROM [DB]qt_resprocessing",true,false);
runSQL('',"ALTER TABLE [DB]qt_resprocessing CHANGE Correct correct tinyint(1) NOT NULL default '0'","SELECT Correct FROM [DB]qt_resprocessing",true,false);
runSQL('',"ALTER TABLE [DB]qt_resprocessing CHANGE Score score FLOAT(3,1) NOT NULL default '0'","SELECT Score FROM [DB]qt_resprocessing",true,false);
runSQL('',"ALTER TABLE [DB]qt_resprocessing CHANGE FeedbackType feedback_type varchar(100) NOT NULL default ''","SELECT FeedbackType FROM [DB]qt_resprocessing",true,false);
runSQL('',"ALTER TABLE [DB]qt_resprocessing CHANGE Feedbacklinkrefid feedback_linkref_id varchar(100) NOT NULL default ''","SELECT Feedbacklinkrefid FROM [DB]qt_resprocessing",true,false);

runSQL('',"RENAME TABLE [DB]QTFeedback TO [DB]qt_feedback","SELECT * FROM [DB]QTFeedback",true,false);
runSQL('',"ALTER TABLE [DB]qt_feedback CHANGE ItemKey item_key int(11) NOT NULL default '0'","SELECT ItemKey FROM [DB]qt_feedback",true,false);
runSQL('',"ALTER TABLE [DB]qt_feedback CHANGE FeedbackLinkrefid feedback_linkref_id varchar(100) NOT NULL default ''","SELECT FeedbackLinkrefid FROM [DB]qt_feedback",true,false);
runSQL('',"ALTER TABLE [DB]qt_feedback CHANGE Mattext mattext text NOT NULL default ''","SELECT Mattext FROM [DB]qt_feedback",true,false);

runSQL('',"RENAME TABLE [DB]QTCategories TO [DB]qt_categories","SELECT * FROM [DB]QTCategories",true,false);
runSQL('',"ALTER TABLE [DB]qt_categories CHANGE CategoryKey category_key int(11) NOT NULL auto_increment","SELECT CategoryKey FROM [DB]qt_categories",true,false);
runSQL('',"ALTER TABLE [DB]qt_categories CHANGE ParentKey parent_key int(11) NOT NULL default '0'","SELECT ParentKey FROM [DB]qt_categories",true,false);
runSQL('',"ALTER TABLE [DB]qt_categories CHANGE Name name varchar(255) NOT NULL default ''","SELECT Name FROM [DB]qt_categories",true,false);
runSQL('',"ALTER TABLE [DB]qt_categories CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]qt_categories",true,false);
runSQL('',"ALTER TABLE [DB]qt_categories CHANGE SpaceKey space_key int(11) NOT NULL default '0'","SELECT SpaceKey FROM [DB]qt_categories",true,false);

runSQL('',"RENAME TABLE [DB]QTCategoryItemLinks TO [DB]qt_category_item_links","SELECT * FROM [DB]QTCategoryItemLinks",true,false);
runSQL('',"ALTER TABLE [DB]qt_category_item_links CHANGE CategoryKey category_key int(11) NOT NULL","SELECT CategoryKey FROM [DB]qt_category_item_links",true,false);
runSQL('',"ALTER TABLE [DB]qt_category_item_links CHANGE ItemKey item_key int(11) NOT NULL ","SELECT ItemKey FROM [DB]qt_category_item_links",true,false);

runSQL('',"RENAME TABLE [DB]QTModuleItemLinks TO [DB]qt_module_item_links","SELECT * FROM [DB]QTModuleItemLinks",true,false);
runSQL('',"ALTER TABLE [DB]qt_module_item_links CHANGE LinkKey link_key int(11) NOT NULL auto_increment","SELECT LinkKey FROM [DB]qt_module_item_links",true,false); 
runSQL('',"ALTER TABLE [DB]qt_module_item_links CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]qt_module_item_links",true,false);
runSQL('',"ALTER TABLE [DB]qt_module_item_links CHANGE ItemKey item_key int(11) NOT NULL default '0'","SELECT ItemKey FROM [DB]qt_module_item_links",true,false);
runSQL('',"ALTER TABLE [DB]qt_module_item_links CHANGE SortOrder sort_order int(4) NOT NULL default '0'","SELECT SortOrder FROM [DB]qt_module_item_links",true,false);
runSQL('',"ALTER TABLE [DB]qt_module_item_links CHANGE Score score FLOAT(3,1) NOT NULL default '0'","SELECT Score FROM [DB]qt_module_item_links",true,false);

runSQL('',"RENAME TABLE [DB]QTAttempts TO [DB]qt_attempts","SELECT * FROM [DB]QTAttempts",true,false);
runSQL('',"ALTER TABLE [DB]qt_attempts CHANGE AttemptKey attempt_key int(11) NOT NULL auto_increment","SELECT AttemptKey FROM [DB]qt_attempts",true,false); 
runSQL('',"ALTER TABLE [DB]qt_attempts CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]qt_attempts",true,false);
runSQL('',"ALTER TABLE [DB]qt_attempts CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]qt_attempts",true,false);
runSQL('',"ALTER TABLE [DB]qt_attempts CHANGE TimeStarted time_started datetime NOT NULL default '0000-00-00 00:00:00'","SELECT TimeStarted FROM [DB]qt_attempts",true,false); 
runSQL('',"ALTER TABLE [DB]qt_attempts CHANGE TimeFinished time_finished datetime NOT NULL default '0000-00-00 00:00:00'","SELECT TimeFinished FROM [DB]qt_attempts",true,false);
runSQL('',"ALTER TABLE [DB]qt_attempts CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]qt_attempts",true,false); 
runSQL('',"ALTER TABLE [DB]qt_attempts CHANGE Score score int(4) NOT NULL default '0'","SELECT Score FROM [DB]qt_attempts",true,false);

runSQL('',"RENAME TABLE [DB]QTAttemptsData TO [DB]qt_attempts_data","SELECT * FROM [DB]QTAttemptsData",true,false);
runSQL('',"ALTER TABLE [DB]qt_attempts_data CHANGE AttemptKey attempt_key int(11) NOT NULL auto_increment","SELECT AttemptKey FROM [DB]qt_attempts_data",true,false); 
runSQL('',"ALTER TABLE [DB]qt_attempts_data CHANGE ItemKey item_key int(11) NOT NULL default '0'","SELECT ItemKey FROM [DB]qt_attempts_data",true,false);
runSQL('',"ALTER TABLE [DB]qt_attempts_data CHANGE ResponseIdent response_ident varchar(100) NOT NULL default ''","SELECT ResponseIdent FROM [DB]qt_attempts_data",true,false);
runSQL('',"ALTER TABLE [DB]qt_attempts_data CHANGE ResponseText response_text text NOT NULL default ''","SELECT ResponseText FROM [DB]qt_attempts_data",true,false);
runSQL('',"ALTER TABLE [DB]qt_attempts_data CHANGE Correct correct tinyint(1) NOT NULL default '0'","SELECT Correct FROM [DB]qt_attempts_data",true,false); 

runSQL('',"RENAME TABLE [DB]SharedItemComments TO [DB]shared_item_comments","SELECT * FROM [DB]SharedItemComments",true,false);
runSQL('',"ALTER TABLE [DB]shared_item_comments CHANGE CommentKey comment_key int(11) NOT NULL auto_increment","SELECT CommentKey FROM [DB]shared_item_comments",true,false);
runSQL('',"ALTER TABLE [DB]shared_item_comments CHANGE SharedItemKey shared_item_key int(11) NOT NULL default '0'","SELECT SharedItemKey FROM [DB]shared_item_comments",true,false);
runSQL('',"ALTER TABLE [DB]shared_item_comments CHANGE ParentKey parent_key int(11) NOT NULL default '0'","SELECT ParentKey FROM [DB]shared_item_comments",true,false);
runSQL('',"ALTER TABLE [DB]shared_item_comments CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]shared_item_comments",true,false);
runSQL('',"ALTER TABLE [DB]shared_item_comments CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]shared_item_comments",true,false);
runSQL('',"ALTER TABLE [DB]shared_item_comments CHANGE Subject subject varchar(50) NOT NULL default ''","SELECT Subject FROM [DB]shared_item_comments",true,false);
runSQL('',"ALTER TABLE [DB]shared_item_comments CHANGE Body body text NOT NULL","SELECT Body FROM [DB]shared_item_comments",true,false);
runSQL('',"ALTER TABLE [DB]shared_item_comments CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]shared_item_comments",true,false);

runSQL('',"RENAME TABLE [DB]SharedItems TO [DB]shared_items","SELECT * FROM [DB]SharedItems",true,false);
runSQL('',"ALTER TABLE [DB]shared_items CHANGE SharedItemKey shared_item_key int(11) NOT NULL auto_increment","SELECT SharedItemKey FROM [DB]shared_items",true,false);
runSQL('',"ALTER TABLE [DB]shared_items CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]shared_items",true,false);
runSQL('',"ALTER TABLE [DB]shared_items CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]shared_items",true,false);
runSQL('',"ALTER TABLE [DB]shared_items CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]shared_items",true,false);
runSQL('',"ALTER TABLE [DB]shared_items CHANGE Name name varchar(100) NOT NULL default ''","SELECT Name FROM [DB]shared_items",true,false);
runSQL('',"ALTER TABLE [DB]shared_items CHANGE Description description text NOT NULL","SELECT Description FROM [DB]shared_items",true,false);
runSQL('',"ALTER TABLE [DB]shared_items CHANGE Url url varchar(100) NOT NULL default ''","SELECT Url FROM [DB]shared_items",true,false);
runSQL('',"ALTER TABLE [DB]shared_items CHANGE FileName filename varchar(50) NOT NULL default ''","SELECT FileName FROM [DB]shared_items",true,false);
runSQL('',"ALTER TABLE [DB]shared_items CHANGE FilePath file_path varchar(11) NOT NULL default ''","SELECT FilePath FROM [DB]shared_items",true,false); 

runSQL('',"RENAME TABLE [DB]SharingSettings TO [DB]sharing_settings","SELECT * FROM [DB]SharingSettings",true,false);
runSQL('',"ALTER TABLE [DB]sharing_settings CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]sharing_settings",true,false);
runSQL('',"ALTER TABLE [DB]sharing_settings CHANGE FilePath file_path varchar(20) NOT NULL default ''","SELECT FilePath FROM [DB]sharing_settings",true,false);

runSQL('',"RENAME TABLE [DB]Skins TO [DB]Skins_temp","SELECT * FROM [DB]Skins",true,false);
runSQL('',"RENAME TABLE [DB]Skins_temp TO [DB]skins","SELECT * FROM [DB]Skins_temp",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE SkinKey skin_key int(11) NOT NULL auto_increment","SELECT SkinKey FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE Template template varchar(20) NOT NULL default ''","SELECT Template FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE ScopeKey scope_key tinyint(2) NOT NULL default '0'","SELECT ScopeKey FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE Name name varchar(20) NOT NULL default ''","SELECT Name FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE BodyBackground body_background varchar(11) NOT NULL default ''","SELECT BodyBackground FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE BodyFont body_font varchar(50) NOT NULL default ''","SELECT BodyFont FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE BodyBorderColour body_border_colour varchar(11) NOT NULL default ''","SELECT BodyBorderColour FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE OuterBoxBackground outer_box_background varchar(11) NOT NULL default ''","SELECT OuterBoxBackground FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE OuterBoxBorderColour outer_box_border_colour varchar(11) NOT NULL default ''","SELECT OuterBoxBorderColour FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE HeaderLogo header_logo varchar(255) NOT NULL default ''","SELECT HeaderLogo FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE HeaderLogoHeight header_logo_height varchar(6) NOT NULL default ''","SELECT HeaderLogoHeight FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE HeaderLogoWidth header_logo_width varchar(6) NOT NULL default ''","SELECT HeaderLogoWidth FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE HeaderHeight header_height varchar(6) NOT NULL default ''","SELECT HeaderHeight FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE HeaderBackground header_background varchar(11) NOT NULL default ''","SELECT HeaderBackground FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE HeaderBorderColour header_border_colour varchar(50) NOT NULL default ''","SELECT HeaderBorderColour FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE ServernameColour server_name_colour varchar(11) NOT NULL default ''","SELECT ServernameColour FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE InnerBoxBackground inner_box_background varchar(11) NOT NULL default ''","SELECT InnerBoxBackground FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE InnerBoxBorderColour inner_box_border_colour varchar(11) NOT NULL default ''","SELECT InnerBoxBorderColour FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE NavBackground nav_background varchar(11) NOT NULL default ''","SELECT NavBackground FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE NavBorderColour nav_border_colour varchar(11) NOT NULL default ''","SELECT NavBorderColour FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE ContentBackground content_background varchar(11) NOT NULL default ''","SELECT ContentBackground FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE ContentBorderColour content_border_colour varchar(11) NOT NULL default ''","SELECT ContentBorderColour FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE RawCss raw_css text NOT NULL default ''","SELECT RawCss FROM [DB]skins",true,false);
runSQL('',"ALTER TABLE [DB]skins CHANGE Version version int(10) NOT NULL default 0","SELECT Version FROM [DB]skins",true,false);

runSQL('',"RENAME TABLE [DB]SortOrders TO [DB]sort_orders","SELECT * FROM [DB]SortOrders",true,false);
runSQL('',"ALTER TABLE [DB]sort_orders CHANGE SortOrderKey sort_order_key tinyint(4) NOT NULL auto_increment","SELECT SortOrderKey FROM [DB]sort_orders",true,false);
runSQL('',"ALTER TABLE [DB]sort_orders CHANGE SortOrder sort_order varchar(20) NOT NULL default ''","SELECT SortOrder FROM [DB]sort_orders",true,false);
runSQL('',"ALTER TABLE [DB]sort_orders CHANGE SortSql sort_sql varchar(30) NOT NULL default ''","SELECT SortSql FROM [DB]sort_orders",true,false);

dropTable("SpaceChildLinks");
dropTable("SpaceStatus");
dropTable("SpaceType");

runSQL('',"RENAME TABLE [DB]SpaceUserLinks TO [DB]space_user_links","SELECT * FROM [DB]SpaceUserLinks",true,false);
runSQL('',"ALTER TABLE [DB]space_user_links CHANGE SpaceKey space_key int(11) NOT NULL default '0'","SELECT SpaceKey FROM [DB]space_user_links",true,false);
runSQL('',"ALTER TABLE [DB]space_user_links CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]space_user_links",true,false);
runSQL('',"ALTER TABLE [DB]space_user_links CHANGE AccessLevelKey access_level_key tinyint(4) NOT NULL default '0'","SELECT AccessLevelKey FROM [DB]space_user_links",true,false);
runSQL('',"ALTER TABLE [DB]space_user_links CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]space_user_links",true,false);

runSQL('',"RENAME TABLE [DB]Spaces TO [DB]Spaces_temp","SELECT * FROM [DB]Spaces",true,false);
runSQL('',"RENAME TABLE [DB]Spaces_temp TO [DB]spaces","SELECT * FROM [DB]Spaces_temp",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE SpaceKey space_key int(11) NOT NULL auto_increment","SELECT SpaceKey FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE SkinKey skin_key int(11) NOT NULL default '0'","SELECT SkinKey FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE Code code varchar(20) NOT NULL default ''","SELECT Code FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE ShortName short_name varchar(20) NOT NULL default ''","SELECT ShortName FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE CombineNames combine_names tinyint(1) NOT NULL default '0'","SELECT CombineNames FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE Name name varchar(100) NOT NULL default ''","SELECT Name FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE Description description varchar(255) NOT NULL default ''","SELECT Description FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE AccessLevelKey access_level_key tinyint(4) NOT NULL default '0'","SELECT AccessLevelKey FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE VisibilityKey visibility_key tinyint(4) NOT NULL default '0'","SELECT VisibilityKey FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE TypeKey type_key tinyint(1) not null default '0'","SELECT TypeKey FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE OwnedByKey owned_by_key int(11) not null default '0'","SELECT OwnedByKey FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE FilePath file_path varchar(20) NOT NULL default ''","SELECT FilePath FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE AccessCode access_code varchar(15) NOT NULL default ''","SELECT AccessCode FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE NewUserAlert new_user_alert varchar(5) NOT NULL default ''","SELECT NewUserAlert FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE Header header mediumtext NOT NULL default ''","SELECT Header FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE ShortDateFormatKey short_date_format_key tinyint(4) NOT NULL default '0'","SELECT ShortDateFormatKey FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE LongDateFormatKey long_date_format_key tinyint(4) NOT NULL default '0'","SELECT LongDateFormatKey FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE SortOrder sort_order int(3) NOT NULL default '0'","SELECT SortOrder FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE ShowMembers show_members tinyint(1) NOT NULL default '1'","SELECT ShowMembers FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE SpaceMap space_map tinyint(1) NOT NULL default '0'","SELECT SpaceMap FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE AltHome alt_home varchar(255) NOT NULL default ''","SELECT AltHome FROM [DB]spaces",true,false);
runSQL('',"ALTER TABLE [DB]spaces CHANGE WelcomeMessage welcome_message MediumText NOT NULL default ''","SELECT WelcomeMessage FROM [DB]spaces",true,false);

runSQL('',"RENAME TABLE [DB]Statistics TO [DB]Statistics_temp","SELECT * FROM [DB]Statistics",true,false);
runSQL('',"RENAME TABLE [DB]Statistics_temp TO [DB]statistics","SELECT * FROM [DB]Statistics_temp",true,false);
runSQL('',"ALTER TABLE [DB]statistics CHANGE SpaceKey space_key int(11) NOT NULL default '0'","SELECT SpaceKey FROM [DB]statistics",true,false);
runSQL('',"ALTER TABLE [DB]statistics CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]statistics",true,false);
runSQL('',"ALTER TABLE [DB]statistics CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]statistics",true,false);
runSQL('',"ALTER TABLE [DB]statistics CHANGE DateAccessed date_accessed datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAccessed FROM [DB]statistics",true,false);
runSQL('',"ALTER TABLE [DB]statistics CHANGE UseType use_type varchar(5) NOT NULL default ''","SELECT UseType FROM [DB]statistics",true,false);
runSQL('',"ALTER TABLE [DB]statistics CHANGE Location location varchar(40) NOT NULL default ''","SELECT Location FROM [DB]statistics",true,false);

runSQL('',"RENAME TABLE [DB]UserGroups TO [DB]user_groups","SELECT * FROM [DB]UserGroups",true,false);
runSQL('',"ALTER TABLE [DB]user_groups CHANGE UserGroupKey user_group_key int(6) NOT NULL auto_increment","SELECT UserGroupKey FROM [DB]user_groups",true,false);
runSQL('',"ALTER TABLE [DB]user_groups CHANGE GroupName group_name varchar(50) NOT NULL default ''","SELECT GroupName FROM [DB]user_groups",true,false);
runSQL('',"ALTER TABLE [DB]user_groups CHANGE AccountCreationPassword account_creation_password varchar(15) NOT NULL default ''","SELECT AccountCreationPassword FROM [DB]user_groups",true,false);

runSQL('',"RENAME TABLE [DB]UserUserGroupLinks TO [DB]user_usergroup_links","SELECT * FROM [DB]UserUserGroupLinks",true,false);
runSQL('',"ALTER TABLE [DB]user_usergroup_links CHANGE UserKey user_key int(11) NOT NULL default '0'","SELECT UserKey FROM [DB]user_usergroup_links",true,false);
runSQL('',"ALTER TABLE [DB]user_usergroup_links CHANGE UserGroupKey user_group_key int(11) NOT NULL default '0'","SELECT UserGroupKey FROM [DB]user_usergroup_links",true,false);

runSQL('',"RENAME TABLE [DB]UserStatuses TO [DB]user_statuses","SELECT * FROM [DB]UserStatuses",true,false);
runSQL('',"ALTER TABLE [DB]user_statuses CHANGE AccountStatusKey account_status_key tinyint(4) NOT NULL auto_increment","SELECT AccountStatusKey FROM [DB]user_statuses",true,false);
runSQL('',"ALTER TABLE [DB]user_statuses CHANGE Name name varchar(20) NOT NULL default ''","SELECT Name FROM [DB]user_statuses",true,false);

runSQL('',"RENAME TABLE [DB]WebLinks TO [DB]weblinks_temp","SELECT * FROM [DB]WebLinks",true,false);
runSQL('',"RENAME TABLE [DB]weblinks_temp TO [DB]weblinks","SELECT * FROM [DB]weblinks_temp",true,false);
runSQL('',"ALTER TABLE [DB]weblinks CHANGE ModuleKey module_key int(11) NOT NULL default '0'","SELECT ModuleKey FROM [DB]weblinks",true,false);
runSQL('',"ALTER TABLE [DB]weblinks CHANGE Url url varchar(200) NOT NULL default ''","SELECT Url FROM [DB]weblinks",true,false);

runSQL('',"RENAME TABLE [DB]Version TO [DB]Version_temp","SELECT * FROM [DB]Version",true,false);
runSQL('',"RENAME TABLE [DB]Version_temp TO [DB]version","SELECT * FROM [DB]Version_temp",true,false);
runSQL('',"ALTER TABLE [DB]version CHANGE Version version int(11) NOT NULL default '0'","SELECT Version FROM [DB]version",true,false);
runSQL('',"ALTER TABLE [DB]version CHANGE ReleaseName release_name varchar(10) NOT NULL default ''","SELECT ReleaseName FROM [DB]version",true,false);

runSQL('',"ALTER TABLE [DB]tagged_urls CHANGE UrlKey url_key int(11) NOT NULL auto_increment","SELECT UrlKey FROM [DB]tagged_urls",true,false);
runSQL('',"ALTER TABLE [DB]tagged_urls CHANGE Url url varchar(255) NOT NULL default ''","SELECT Url FROM [DB]tagged_urls",true,false);
runSQL('',"ALTER TABLE [DB]tagged_urls CHANGE Heading heading varchar(100) not null default ''","SELECT Heading FROM [DB]tagged_urls",true,false);
runSQL('',"ALTER TABLE [DB]tagged_urls CHANGE Note note text NOT NULL default ''","SELECT Note FROM [DB]tagged_urls",true,false);
runSQL('',"ALTER TABLE [DB]tagged_urls CHANGE AddedForKey added_for_key int(11) NOT NULL default '0'","SELECT AddedForKey FROM [DB]tagged_urls",true,false);
runSQL('',"ALTER TABLE [DB]tagged_urls CHANGE AddedByKey added_by_key int(11) NOT NULL default '0'","SELECT AddedByKey FROM [DB]tagged_urls",true,false);
runSQL('',"ALTER TABLE [DB]tagged_urls CHANGE SpaceKey space_key int(11) NOT NULL default '0'","SELECT SpaceKey FROM [DB]tagged_urls",true,false);
runSQL('',"ALTER TABLE [DB]tagged_urls CHANGE GroupKey group_key int(11) NOT NULL default '0'","SELECT GroupKey FROM [DB]tagged_urls",true,false);
runSQL('',"ALTER TABLE [DB]tagged_urls CHANGE DateAdded date_added datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateAdded FROM [DB]tagged_urls",true,false);
runSQL('',"ALTER TABLE [DB]tagged_urls CHANGE ModifiedByKey modified_by_key int(11) NOT NULL default '0'","SELECT ModifiedByKey FROM [DB]tagged_urls",true,false);
runSQL('',"ALTER TABLE [DB]tagged_urls CHANGE DateModified date_modified datetime NOT NULL default '0000-00-00 00:00:00'","SELECT DateModified FROM [DB]tagged_urls",true,false);

addColumn("modules","type_code varchar(20) NOT NULL default '' AFTER module_type_key");

runSQL('',"ALTER TABLE [DB]module_types DROP name","SELECT name FROM [DB]module_types",true,false);
runSQL('',"ALTER TABLE [DB]module_types DROP url","SELECT url FROM [DB]module_types",true,false);
runSQL('',"ALTER TABLE [DB]module_types DROP admin_url","SELECT admin_url FROM [DB]module_types",true,false);
runSQL('',"ALTER TABLE [DB]module_types DROP image","SELECT image FROM [DB]module_types",true,false);
runSQL('',"ALTER TABLE [DB]module_types DROP module_type_key","SELECT module_type_key FROM [DB]module_types",true,false);

addColumn("module_types","active tinyint(1) NOT NULL default '0' AFTER code");

runSQL('',"UPDATE [DB]module_types set active='1'");
runSQL('',"UPDATE [DB]sort_orders set sort_sql='modules.date_added' where sort_order_key='1'");
runSQL('',"UPDATE [DB]sort_orders set sort_sql='modules.date_added DESC' where sort_order_key='2'");
runSQL('',"UPDATE [DB]sort_orders set sort_sql='module_space_links.sort_order' where sort_order_key='3'");
runSQL('',"UPDATE [DB]sort_orders set sort_sql='modules.name' where sort_order_key='4'");
runSQL('',"UPDATE [DB]sort_orders set sort_sql='modules.date_modified' where sort_order_key='5'");
runSQL('',"UPDATE [DB]sort_orders set sort_sql='modules.date_modified DESC' where sort_order_key='6'");
runSQL('',"UPDATE [DB]posts SET date_published=date_added where date_published='0000-00-00 00:00:00'");
runSQL('',"UPDATE [DB]users SET account_status=1 where username='admin'");

	if ($verbo) echo '<span class="message">Updating module type codes&hellip;</span><br />';
	$module_types = array(
	1=>'file',
	2=>'weblink',
	3=>'forum',
	4=>'folder',
	5=>'note',
	6=>'group',
	7=>'calendar',
	8=>'dropbox',
	9=>'sharing',
	10=>'heading',
	12=>'page',
	13=>'chat',
	14=>'journal',
	15=>'noticeboard',
	16=>'gradebook',
	17=>'quiz',
	18=>'kb',
	19=>'space',
	20=>'scorm',
	21=>'feedreader'
);
	$rs = $CONN->Execute("SELECT module_key, module_type_key, type_code FROM {$CONFIG['DB_PREFIX']}modules");
	while (!$rs->EOF){
		if($rs->fields[1]>0 && $rs->fields[1]<22 && empty($rs->fields[2])) {
			$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}modules SET type_code='".$module_types[$rs->fields[1]]."' WHERE module_key='".$rs->fields[0]."'");
		}
		$rs->MoveNext();
	}
	
	runSQL('Lengthen post subject.',"ALTER TABLE [DB]posts CHANGE subject subject varchar(120)");
	
	addColumn("skins","text_colour varchar(11) NOT NULL DEFAULT '' AFTER content_border_colour");
	addColumn("skins","colour1 varchar(11) NOT NULL DEFAULT '' AFTER text_colour");
	addColumn("skins","colour2 varchar(11) NOT NULL DEFAULT '' AFTER colour1");

	if ($verbo) echo '<span class="message">Modify skin versions.</span><br />';
	$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}skins SET version='".time()."'");
} //end run2007052801Upgrade

function run2007060801Upgrade() {
	global $CONN, $CONFIG, $verbo, $smartnet, $general_strings;

} //end run200706080Upgrade

function run2007070301Upgrade() {
	global $CONN, $CONFIG, $verbo, $smartnet, $general_strings;
	addColumn("news","options tinyint(1) NOT NULL DEFAULT '0' AFTER user_key");
} //end run2007070301Upgrade

function run2007072301Upgrade() {
	global $CONN, $CONFIG, $verbo, $smartnet, $general_strings;
	runSQL('Increase field_key limit on kb_entry_data',"ALTER TABLE [DB]kb_entry_data CHANGE field_key field_key int(11) NOT NULL DEFAULT '0'");	
	runSQL('Remove extraneous index in [DB]files',"ALTER TABLE [DB]files DROP INDEX module_keyIdx",'',false,false,false);
	runSQL('Change [DB]posts body field type','ALTER TABLE [DB]posts CHANGE body body text NOT NULL DEFAULT ""',false,false,true);
	runSQL('Add fulltext search indexes to [DB]posts table',"CREATE FULLTEXT INDEX postsfulltext ON [DB]posts(subject,body)",false,false,true);
	runSQL('Add fulltext search indexes to [DB]modules table',"CREATE FULLTEXT INDEX modulesfulltext ON [DB]modules(name,description)",false,false,true);
	runSQL('Add fulltext search indexes to [DB]spaces table',"CREATE FULLTEXT INDEX spacesfulltext ON [DB]spaces(name,short_name,code,description)",false,false,true); 
} //end run2007072301Upgrade

function run2007120301Upgrade() {
	global $CONN, $CONFIG, $verbo, $smartnet, $general_strings;
	//no database changes needed for this upgrade.
} //end run2007110101Upgrade

// Upgrade function template
// -------------------------
// Upon new release, copy this template, paste version number over ______ and
// move contents of run_DEV_Upgrade into it.

// echo of Release and update of Version table is now handled by main upgrade loop.
function run______Upgrade() {
	global $CONN, $CONFIG, $verbo, $smartnet, $general_strings;

} //end run______Upgrade


function run_DEV_Upgrade() {
//////////////////////////////////
	global $CONN, $CONFIG, $verbo, $smartnet, $general_strings;


} //end run_DEV_upgrade
?>