CREATE TABLE interact_Version (
  Version int(11) NOT NULL default '0',
  Release varchar(10) NOT NULL default ''
) TYPE=MyISAM;
INSERT INTO interact_Version VALUES ('2003120101','1.8.6');

INSERT INTO interact_ModuleTypes VALUES ('','Gradebook','gradebook','','','gradebook');
INSERT INTO interact_UserStatuses VALUES ('','To be deleted');
#
# Table structure for table 'interact_GradebookItems'
#

CREATE TABLE interact_GradebookItems (
  ItemKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  ScaleKey int(11) NOT NULL default '0',
  Name varchar(100) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  Url varchar(150) NOT NULL default '', 
  ContentModuleKey int(11) NOT NULL default '0',  
  SortOrder tinyint(3) NOT NULL default '0', 
  DueDate datetime NOT NULL default '0000-00-00 00:00:00',
  MaximumScore tinyint(3) NOT NULL default '0',
  Weighting tinyint(3) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ItemKey)
) TYPE=MyISAM;

#
# Table structure for table 'interact_GradebookItemUserLinks'
#

CREATE TABLE interact_GradebookItemUserLinks (
  ItemKey int(11) NOT NULL auto_increment,
  UserKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  GradeKey int(3) NOT NULL default '0',
  Comments mediumtext NOT NULL,   
  UNIQUE(ItemKey, UserKey)
) TYPE=MyISAM;

#
# Table structure for table 'interact_GradebookScales'
#

#
# Table structure for table 'interact_GradebookScales'
#

CREATE TABLE interact_GradebookScales (
  ScaleKey int(11) NOT NULL auto_increment,
  Name varchar(100) NOT NULL default '',
  Description text NOT NULL default '',
  SpaceKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ScaleKey)
) TYPE=MyISAM;

INSERT INTO interact_GradebookScales VALUES (1,'Numeric','Standard numeric scale',0,0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScales VALUES (2,'Alpha','Standard a-f Alpha scale',0,0,'2003-11-03 10:02:23',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScales VALUES (3,'Pass/Fail','',0,0,'2003-11-03 10:05:25',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScales VALUES (4,'Complete','Basic complete/incomplete grading',0,0,'2003-11-03 10:06:33',0,'0000-00-00 00:00:00');


#
# Table structure for table 'interact_GradebookScaleGrades'
#

CREATE TABLE interact_GradebookScaleGrades (
  GradeKey int(11) NOT NULL auto_increment,  
  ScaleKey int(11) NOT NULL default '0',
  Grade varchar(255) NOT NULL default '',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (GradeKey)
) TYPE=MyISAM;

INSERT INTO interact_GradebookScaleGrades VALUES (1,2,'A',1,'2003-11-03 10:03:36',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (2,2,'A+',1,'2003-11-03 10:03:44',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (3,2,'A-',1,'2003-11-03 10:03:49',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (4,2,'B',1,'2003-11-03 10:03:53',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (5,2,'B+',1,'2003-11-03 10:03:58',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (6,2,'B-',1,'2003-11-03 10:04:03',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (7,2,'C',1,'2003-11-03 10:04:09',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (8,2,'C+',1,'2003-11-03 10:04:13',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (9,2,'C-',1,'2003-11-03 10:04:18',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (10,2,'D',1,'2003-11-03 10:04:22',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (11,2,'D+',1,'2003-11-03 10:04:27',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (12,2,'D-',1,'2003-11-03 10:04:31',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (13,2,'E',1,'2003-11-03 10:04:37',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (14,2,'E+',1,'2003-11-03 10:04:45',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (15,2,'E-',1,'2003-11-03 10:04:50',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (16,2,'F',1,'2003-11-03 10:04:54',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (17,3,'Pass',1,'2003-11-03 10:05:37',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (18,3,'Fail',1,'2003-11-03 10:05:42',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (19,3,'Resubmit',1,'2003-11-03 10:05:49',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (20,3,'Pass with distinction',1,'2003-11-03 10:06:02',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (21,3,'Complete',1,'2003-11-03 10:06:45',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (22,3,'Incomplete',1,'2003-11-03 10:06:45',0,'0000-00-00 00:00:00');

INSERT INTO interact_Users VALUES ('','deleteduser','xyz123','','Deleted','User','deleted@deleteduser.com','Account used when deleting users from system - do not remove','4','','','','','','2','1');

#
# Table structure for table 'UserNotes'
#
CREATE TABLE interact_UserNotes (
  UserNoteKey tinyint(4) NOT NULL auto_increment,
  Url varchar(255) NOT NULL default '',
  Note text NOT NULL default '',
  AddedForKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  SpaceKey int(11) NOT NULL default '0',    
  GroupKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (UserNoteKey),
  KEY AddedForKeyIdx (AddedForKey),
  KEY SpaceKeyIdx (SpaceKey),
  KEY GroupKeyIdx (GroupKey)

) TYPE=MyISAM;

ALTER TABLE interact_DropboxFiles ADD GradebookItemKey int(11) NOT NULL default '0' AFTER UserKey; 

CREATE TABLE interact_DateFormats (
  FormatKey int(11) NOT NULL default '0',
  Format varchar(15) NOT NULL default '',
  Type varchar(5) NOT NULL default ''  

) TYPE=MyISAM;


INSERT INTO interact_DateFormats VALUES (0,'dd-mm-yy','short');
INSERT INTO interact_DateFormats VALUES (1,'mm-dd-yy','short');
INSERT INTO interact_DateFormats VALUES (2,'d-m-yy','short');
INSERT INTO interact_DateFormats VALUES (3,'m-d-yy','short');
INSERT INTO interact_DateFormats VALUES (4,'dd-mm-yyyy','short');
INSERT INTO interact_DateFormats VALUES (5,'mm-dd-yyyy','short');
INSERT INTO interact_DateFormats VALUES (6,'d-m-yyyy','short');
INSERT INTO interact_DateFormats VALUES (7,'m-d-yyyy','short');
INSERT INTO interact_DateFormats VALUES (0,'d Jan 2003','long');
INSERT INTO interact_DateFormats VALUES (1,'d January 2003','long');
INSERT INTO interact_DateFormats VALUES (2,'January d 2003','long');
INSERT INTO interact_DateFormats VALUES (3,'Jan d 2003','long');

ALTER TABLE interact_Spaces ADD ShortDateFormatKey tinyint(4) NOT NULL AFTER Header;
ALTER TABLE interact_Spaces ADD LongDateFormatKey  tinyint(4) NOT NULL AFTER Header;
INSERT INTO interact_SpaceStatus VALUES (3,'Hidden');
INSERT INTO interact_SpaceStatus VALUES (4,'Archived');
INSERT INTO interact_Languages VALUES (3,'tur','Turkish');